function varargout = BPM(varargin)
% BPM M-file for BPM.fig
%      BPM, by itself, creates a new BPM or raises the existing
%      singleton*.
%
%      H = BPM returns the handle to a new BPM or the handle to
%      the existing singleton*.
%
%      BPM('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in BPM.M with the given input arguments.
%
%      BPM('Property','Value',...) creates a new BPM or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before BPM_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to BPM_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help BPM

% Last Modified by GUIDE v2.5 18-Oct-2009 13:28:04

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @BPM_OpeningFcn, ...
                   'gui_OutputFcn',  @BPM_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before BPM is made visible.
function BPM_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to BPM (see VARARGIN)

% Choose default command line output for BPM
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes BPM wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = BPM_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



function R1_edit_Callback(hObject, eventdata, handles)
% hObject    handle to R1_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of R1_edit as text
%        str2double(get(hObject,'String')) returns contents of R1_edit as a double


% --- Executes during object creation, after setting all properties.
function R1_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to R1_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in plot_input.
function plot_input_Callback(hObject, eventdata, handles)

h=guidata(hObject);
R1=str2num(get(h.R1_edit,'string'));
R2=str2num(get(h.R2_edit,'string'));
w0=str2num(get(h.w0_edit,'string'));
umax=str2num(get(h.umax_edit,'string'));
T=str2num(get(h.T_edit,'string'));
n=get(h.n_edit,'string');
M=str2num(get(h.iter_edit,'string'));
focal=get(h.slider1,'Value');
focal=1.25+100*focal;
checkboxStatus = get(h.lens_check,'Value');
if(checkboxStatus)
    %if box is checked, text is set to bold
    lens=1/focal
else
    %if box is unchecked, text is set to normal
    lens=0
end
delz=0.08;
k=gpm(R1,R2,w0,T,delz,n,lens,M,umax);
dz=squeeze(k(1,:,:));
Fr=squeeze(k(2,:,:));
U=squeeze(k(3,:,:));
waterfall(dz',Fr',U');
title(['R_1=',num2str(R1),'R_2=',num2str(R2),'w_0=',num2str(w0)]);
zlabel('Beam intensity')
xlabel('r')
ylabel('z')

% hObject    handle to plot_input (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)





function R2_edit_Callback(hObject, eventdata, handles)
% hObject    handle to R2_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of R2_edit as text
%        str2double(get(hObject,'String')) returns contents of R2_edit as a double


% --- Executes during object creation, after setting all properties.
function R2_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to R2_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end





function w0_edit_Callback(hObject, eventdata, handles)
% hObject    handle to w0_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of w0_edit as text
%        str2double(get(hObject,'String')) returns contents of w0_edit as a double


% --- Executes during object creation, after setting all properties.
function w0_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to w0_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end





function T_edit_Callback(hObject, eventdata, handles)
% hObject    handle to T_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of T_edit as text
%        str2double(get(hObject,'String')) returns contents of T_edit as a double


% --- Executes during object creation, after setting all properties.
function T_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to T_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end





function n_edit_Callback(hObject, eventdata, handles)
% hObject    handle to n_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of n_edit as text
%        str2double(get(hObject,'String')) returns contents of n_edit as a double


% --- Executes during object creation, after setting all properties.
function n_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to n_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end





function lens_edit_Callback(hObject, eventdata, handles)
% hObject    handle to lens_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of lens_edit as text
%        str2double(get(hObject,'String')) returns contents of lens_edit as a double


% --- Executes during object creation, after setting all properties.
function lens_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to lens_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end





function iter_edit_Callback(hObject, eventdata, handles)
% hObject    handle to iter_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of iter_edit as text
%        str2double(get(hObject,'String')) returns contents of iter_edit as a double


% --- Executes during object creation, after setting all properties.
function iter_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to iter_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end





function umax_edit_Callback(hObject, eventdata, handles)
% hObject    handle to umax_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of umax_edit as text
%        str2double(get(hObject,'String')) returns contents of umax_edit as a double


% --- Executes during object creation, after setting all properties.
function umax_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to umax_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end




% --- Executes on slider movement.
function slider1_Callback(hObject, eventdata, handles)
% hObject    handle to slider1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


% --- Executes during object creation, after setting all properties.
function slider1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background, change
%       'usewhitebg' to 0 to use default.  See ISPC and COMPUTER.
usewhitebg = 1;
if usewhitebg
    set(hObject,'BackgroundColor',[.9 .9 .9]);
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end




% --- Executes on button press in d1_input.
function d1_input_Callback(hObject, eventdata, handles)
% hObject    handle to d1_input (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
h=guidata(hObject);
set(h.R1_edit,'String', '40');
set(h.R2_edit,'String', '40');
set(h.w0_edit,'String', '5');
set(h.umax_edit,'String', '0.632');
set(h.T_edit,'String', '10');
set(h.n_edit,'String', 'x-x.^2');
set(h.iter_edit,'String', '500');
set(h.lens_check,'Value',0);
guidata(hObject, h);

% --- Executes on button press in d2_input.
function d2_input_Callback(hObject, eventdata, handles)
% hObject    handle to d2_input (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
h=guidata(hObject);
set(h.R1_edit,'String', '40');
set(h.R2_edit,'String', '40');
set(h.w0_edit,'String', '3.684');
set(h.umax_edit,'String', '1');
set(h.T_edit,'String', '10');
set(h.n_edit,'String', 'x-x.^2');
set(h.iter_edit,'String', '500');
set(h.lens_check,'Value',0);
guidata(hObject, h);


% --- Executes on button press in d3_input.
function d3_input_Callback(hObject, eventdata, handles)
% hObject    handle to d3_input (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
h=guidata(hObject);
set(h.R1_edit,'String', '40');
set(h.R2_edit,'String', '40');
set(h.w0_edit,'String', '4.8');
set(h.umax_edit,'String', '0.6');
set(h.T_edit,'String', '10');
set(h.n_edit,'String', 'x-x.^2');
set(h.iter_edit,'String', '500');
set(h.lens_check,'Value',0);
guidata(hObject, h);




% --- Executes on button press in lens_check.
function lens_check_Callback(hObject, eventdata, handles)
% hObject    handle to lens_check (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of lens_check




% --- Executes on button press in help_bu.
function help_bu_Callback(hObject, eventdata, handles)
% hObject    handle to help_bu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
h=guidata(hObject);
hlp_status = get(h.help_box, 'Visible')
if strcmp(hlp_status, 'off')
    set(h.help_box, 'Visible','on');
    set(h.help_bu,'String','hide help');
	else
		set(h.help_box, 'Visible','off');
    set(h.help_bu,'String','show help');
end


% --- Executes on selection change in help_box.
function help_box_Callback(hObject, eventdata, handles)
% hObject    handle to help_box (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns help_box contents as cell array
%        contents{get(hObject,'Value')} returns selected item from help_box


% --- Executes during object creation, after setting all properties.
function help_box_CreateFcn(hObject, eventdata, handles)
% hObject    handle to help_box (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end




% --- Executes on button press in d4_input.
function d4_input_Callback(hObject, eventdata, handles)
% hObject    handle to d4_input (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
h=guidata(hObject);
set(h.R1_edit,'String', '20');
set(h.R2_edit,'String', '20');
set(h.w0_edit,'String', '5');
set(h.umax_edit,'String', '1');
set(h.T_edit,'String', '5');
set(h.n_edit,'String', '0');
set(h.iter_edit,'String', '50');
set(h.lens_check,'Value',1);
set(h.slider1,'Value',0.5);
guidata(hObject, h);

