function varargout = capacitance_extraction_gui(varargin)
% capacitance_extraction_gui M-file for capacitance_extraction_gui.fig
%      capacitance_extraction_gui, by itself, creates a new capacitance_extraction_gui or raises the existing
%      singleton*.
%
%      H = capacitance_extraction_gui returns the handle to a new capacitance_extraction_gui or the handle to
%      the existing singleton*.
%
%      capacitance_extraction_gui('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in capacitance_extraction_gui.M with the given input arguments.
%
%      capacitance_extraction_gui('Property','Value',...) creates a new capacitance_extraction_gui or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the capacitance_extraction_gui before capacitance_extraction_gui_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to capacitance_extraction_gui_OpeningFcn via varargin.
%
%      *See capacitance_extraction_gui Options on GUIDE's Tools menu.  Choose "capacitance_extraction_gui allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help capacitance_extraction_gui

% Last Modified by GUIDE v2.5 11-Oct-2009 15:30:08

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @capacitance_extraction_gui_OpeningFcn, ...
                   'gui_OutputFcn',  @capacitance_extraction_gui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before capacitance_extraction_gui is made visible.
function capacitance_extraction_gui_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to capacitance_extraction_gui (see VARARGIN)

% Choose default command line output for capacitance_extraction_gui
handles.output = hObject;

button_reset_Callback(handles.button_reset, eventdata, handles); % Reset everything
handles=guidata(hObject);

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes capacitance_extraction_gui wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = capacitance_extraction_gui_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% --- Executes on button press in button_mesh.
function button_mesh_Callback(hObject, eventdata, handles)
% hObject    handle to button_mesh (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

button_reset_Callback(hObject, eventdata, handles);
handles=guidata(hObject);

temp=get(handles.table_beam_param,'Data'); % Get beam dimensions and mesh parameters
% Dimensions of the first beam
l1=temp(1,1);
t1=temp(1,2);
w1=temp(1,3);

% Dimensions of the second beam
l2=temp(2,1);
t2=temp(2,2);
w2=temp(2,3);

% Number of grid intervals in each direction in the first beam
Nl1=temp(1,4);
Nt1=temp(1,5);
Nw1=temp(1,6);

% Number of grid intervals in each direction in the second beam
Nl2=temp(2,4);
Nt2=temp(2,5);
Nw2=temp(2,6);

if min(min(temp(:,5:6)))<2 % Stop if mesh parameter Nt or Nw is smaller than 2
    errordlg('Mesh parameter Nt or Nw cannot be smaller than 2','Wrong parameter');
    set(handles.text_build_mesh,'String','X','ForegroundColor','red');
    return;
end

if min(min(temp(:,1:6)))<0 % Stop if any parameter is negative
    errordlg('Negative beam dimension or mesh parameter','Wrong parameter');
    set(handles.text_build_mesh,'String','X','ForegroundColor','red');
    return;
end

% Meshing each beam
[node_list1 facet_list1]=mesh_rectangular_prism(l1,t1,w1,Nl1,Nt1,Nw1);
[node_list2 facet_list2]=mesh_rectangular_prism(l2,t2,w2,Nl2,Nt2,Nw2);

if get(handles.radio_save_orig_nodes,'Value') % Save original node lists
    save 'orig_node_list1.txt' node_list1 -ascii -double -tabs
    save 'orig_node_list2.txt' node_list2 -ascii -double -tabs
end
if get(handles.radio_save_orig_facets,'Value') % Save original facet lists
    save 'facet_list1.txt' facet_list1 -ascii -tabs
    save 'facet_list2.txt' facet_list2 -ascii -tabs
end

% Save the results into handles structure
handles.orig_node_list1=node_list1;
handles.orig_node_list2=node_list2;
handles.facet_list1=facet_list1;
handles.facet_list2=facet_list2;

set(handles.text_build_mesh,'String','V','ForegroundColor','green');

guidata(hObject,handles);

% --- Executes on button press in button_form_functions.
function button_form_functions_Callback(hObject, eventdata, handles)
% hObject    handle to button_form_functions (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

temp=get(handles.text_build_mesh,'String');
if ~strcmp(temp,'V') % Previous extraction data does not exist
    errordlg('Data from previous step is unavailable. Please run "Build Mesh" first.','Data unavailable');
    return;
end

button_reset_Callback(hObject, eventdata, handles);
handles=guidata(hObject);

temp=get(handles.table_beam_param,'Data');
node_list1=beam1_form_function(handles.orig_node_list1,temp(1,1),temp(1,2),temp(1,3),temp(1,7));
node_list2=beam2_form_function(handles.orig_node_list2,temp(2,1),temp(2,2),temp(2,3),temp(2,7));

% Combine 2 node and facet lists
handles.number_of_nodes1=size(node_list1,1);
handles.number_of_facets1=size(handles.facet_list1,1);
handles.number_of_nodes2=size(node_list2,1);
handles.number_of_facets2=size(handles.facet_list2,1);
node_list=[node_list1; node_list2];
facet_list=[handles.facet_list1; handles.facet_list2+handles.number_of_nodes1];
handles.number_of_facets=handles.number_of_facets1+handles.number_of_facets2;
handles.number_of_nodes=handles.number_of_nodes1+handles.number_of_nodes2;

% Draw the meshes
cla(handles.main_axes,'reset'); % Clear the axes
hold on;
patch('Vertices',node_list(1:handles.number_of_nodes1,:),'Faces',facet_list(1:handles.number_of_facets1,:),'FaceColor','white','EdgeColor','blue');
patch('Vertices',node_list((handles.number_of_nodes1+1):end,:),'Faces',facet_list((handles.number_of_facets1+1):end,:)-handles.number_of_nodes1,'FaceColor','white','EdgeColor','black');
axis tight;
view(45,60);
xlabel('x','fontweight','b');
ylabel('y','fontweight','b');
zlabel('z','fontweight','b');
hold off;


if get(handles.radio_save_fin_nodes,'Value') % Save final node list
    save 'node_list.txt' node_list -ascii -double -tabs
end
if get(handles.radio_save_fin_facets,'Value') % Save final facet list
    save 'facet_list.txt' facet_list -ascii -tabs
end

handles.node_list=node_list;
handles.facet_list=facet_list;

set(handles.text_apply_form_function,'String','V','ForegroundColor','green');

guidata(hObject,handles);

% --- Executes on button press in button_matrix.
function button_matrix_Callback(hObject, eventdata, handles)
% hObject    handle to button_matrix (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
temp=get(handles.text_apply_form_function,'String');
if ~strcmp(temp,'V') % Previous extraction data does not exist
    errordlg('Data from previous step is unavailable. Please run "Apply Form Functions" first.','Data unavailable');
    return;
end

button_reset_Callback(hObject, eventdata, handles);
handles=guidata(hObject);

% Coordinates of the centers of all the facets
facet_centers=zeros(size(handles.facet_list,1),3); 
facet_centers(:,1)=mean([handles.node_list(handles.facet_list(:,1),1) handles.node_list(handles.facet_list(:,2),1) handles.node_list(handles.facet_list(:,3),1)],2);
facet_centers(:,2)=mean([handles.node_list(handles.facet_list(:,1),2) handles.node_list(handles.facet_list(:,2),2) handles.node_list(handles.facet_list(:,3),2)],2);
facet_centers(:,3)=mean([handles.node_list(handles.facet_list(:,1),3) handles.node_list(handles.facet_list(:,2),3) handles.node_list(handles.facet_list(:,3),3)],2);

temp=cross(handles.node_list(handles.facet_list(:,1),:)-handles.node_list(handles.facet_list(:,3),:),handles.node_list(handles.facet_list(:,2),:)-handles.node_list(handles.facet_list(:,3),:),2);
facet_areas=0.5*sqrt(sum(temp.^2,2)); % Areas of all facets

P=zeros(handles.number_of_facets,handles.number_of_facets); % Operator matrix

% Fill the operator matrix
ten_percent_step=floor(handles.number_of_facets/10); % Integer 1/10 of number_of_facets

for i=1:handles.number_of_facets % For each test point
    if mod(i,ten_percent_step)==0 % Each 10% of number_of_facets
        set(handles.text_build_matrix,'String',num2str(10-i/ten_percent_step),'ForegroundColor','black');
        drawnow;
    end
    for j=1:handles.number_of_facets % Sum over all source facets
        % The three nodes of the self term facet
        a=handles.node_list(handles.facet_list(j,1),:);
        b=handles.node_list(handles.facet_list(j,2),:);
        c=handles.node_list(handles.facet_list(j,3),:);
        
        distance=sqrt(sum((facet_centers(i,:)-facet_centers(j,:)).^2)); % Distance between facets i and j
        if distance<handles.close_field_radius % Close field exact analytical integrationrs(i,:));
            P(i,j)=triangle_analytical_integration(a,b,c,facet_areas(j),facet_centers(i,:));
        else if distance>handles.far_field_radius % Far field centroid approximation
                P(i,j)=facet_areas(j)./sqrt(sum((facet_centers(i,:)-facet_centers(j,:)).^2)); % Centroid approximation
            else % Intermidiate field - Gaussian quadrature
                P(i,j)=triangle_Gaussian_quadrature(a,b,c,facet_areas(j),facet_centers(i,:)); % 7 point Gaussian quadrature
            end
        end
        
    end
end

handles.P=P;
handles.facet_areas=facet_areas;
handles.facet_centers=facet_centers;

if get(handles.radio_save_matrix,'Value') % Save the matrix
    save 'matrix.txt' P -ascii -double -tabs
end

clear P; % Clear the not neaded copy of large matrix

% Matrix image
cla(handles.main_axes,'reset');
image(handles.P/max(max(handles.P))*256);
axis ij; % Upper left corner is (1,1)

set(handles.text_build_matrix,'String','V','ForegroundColor','green');

guidata(hObject,handles);

% --- Executes on button press in button_charges.
function button_charges_Callback(hObject, eventdata, handles)
% hObject    handle to button_charges (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

temp=get(handles.text_build_matrix,'String');
if ~strcmp(temp,'V') % Previous extraction data does not exist
    errordlg('Data from previous step is unavailable. Please run "Build Matrix" first.','Data unavailable');
    return;
end

button_reset_Callback(hObject, eventdata, handles);
handles=guidata(hObject);

epsilon=8.8541878e-12; % Vacuum permiability
sigma1=4*pi()*epsilon*(handles.P\[ones(handles.number_of_facets1,1);zeros(handles.number_of_facets2,1)]).*handles.facet_areas; % V1=1, V2=0
sigma2=4*pi()*epsilon*(handles.P\[zeros(handles.number_of_facets1,1);ones(handles.number_of_facets2,1)]).*handles.facet_areas; % V1=0, V2=1

% Draw the charges on the meshes for V1=1, V2=0
cla(handles.main_axes,'reset'); % Clear the axes
hold on;
patch('Vertices',handles.node_list,'Faces',handles.facet_list,'FaceVertexCData',(sigma1-min(sigma1))/max(sigma1-min(sigma1))*length(colormap),'FaceColor','flat','EdgeColor','black');
axis tight;
view(45,60);
xlabel('x','fontweight','b');
ylabel('y','fontweight','b');
zlabel('z','fontweight','b');
hold off;

if get(handles.radio_save_charges,'Value') % Save the charges
    save 'charges_V1=1_V2=0.txt' sigma1 -ascii -double -tabs
    save 'charges_V1=0_V2=1.txt' sigma2 -ascii -double -tabs
end

set(handles.text_charges,'String','V','ForegroundColor','green');

handles.sigma1=sigma1;
handles.sigma2=sigma2;

guidata(hObject,handles);

% --- Executes on button press in button_capacitances.
function button_capacitances_Callback(hObject, eventdata, handles)
% hObject    handle to button_capacitances (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

temp=get(handles.text_charges,'String');
if ~strcmp(temp,'V') % Previous extraction data does not exist
    errordlg('Data from previous step is unavailable. Please run "Calculate Charges" first.','Data unavailable');
    return;
end

button_reset_Callback(hObject, eventdata, handles);
handles=guidata(hObject);

% Calculate the total capacitance
C12=-sum(handles.sigma2(1:handles.number_of_facets1)); % Cross capacitance when V1=0
C21=-sum(handles.sigma1((handles.number_of_facets1+1):end)); % Cross capacitance when V2=0

C12_avg=(C12+C21)/2;
C10=sum(handles.sigma1(1:handles.number_of_facets1))-C12_avg; % Self capacitance of the first beam
C20=sum(handles.sigma2(handles.number_of_facets1+1:end))-C12_avg; % Self capacitance of the second beam
C_error=abs(C12-C21)/C12_avg*100; % Minimal estimated error as percentage

C11=C10+C12_avg;
C22=C20+C12_avg;

set(handles.text_C11,'String',num2str(C11));
set(handles.text_C12,'String',num2str(-C12_avg));
set(handles.text_C21,'String',num2str(-C12_avg));
set(handles.text_C22,'String',num2str(C22));
set(handles.text_C10,'String',num2str(C10));
set(handles.text_C20,'String',num2str(C20));
set(handles.text_error,'String',[num2str(C_error) '%']);
set(handles.text_caps,'String','V','ForegroundColor','green');

if get(handles.radio_save_caps,'Value') % Save the capacitances
    f=fopen('capacitances.txt','wt');
    fprintf(f,'Capacitance matrix (F)\n%g\t%g\n%g\t%g\n\n',C11,-C12_avg,-C12_avg,C22);
    fprintf(f,'Ground capacitances (F)\nC10\t%g\nC20\t%g\n\n',C10,C20);
    fprintf(f,'Minimal estimated error:\t%g %%',C_error);
    fclose(f);
end

handles.C12=C12;
handles.C21=C21;
handles.C12_avg=C12_avg;
handles.C10=C10;
handles.C20=C20;
handles.C_error=C_error;
handles.C11=C11;
handles.C22=C22;

if get(handles.radio_save_results,'Value') % Save the results in .mat file
    save results.mat handles
end
guidata(hObject,handles);

% --- Executes on button press in button_reset.
function button_reset_Callback(hObject, eventdata, handles)
% hObject    handle to button_reset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

set(handles.text_C11,'String','C11');
set(handles.text_C12,'String','-C12');
set(handles.text_C21,'String','-C21');
set(handles.text_C22,'String','C22');
set(handles.text_C10,'String','C10');
set(handles.text_C20,'String','C20');
set(handles.text_error,'String','diff(C12,C21)/mean(C12,C21)');

set(handles.text_caps,'String','O','ForegroundColor','black');
if hObject==handles.button_capacitances
    guidata(hObject,handles);
    return
end

cla(handles.main_axes,'reset');
set(handles.text_charges,'String','O','ForegroundColor','black');
if hObject==handles.button_charges
    guidata(hObject,handles);
    return
end

set(handles.text_build_matrix,'String','O','ForegroundColor','black');
if hObject==handles.button_matrix
    guidata(hObject,handles);
    return
end

set(handles.text_apply_form_function,'String','O','ForegroundColor','black');
if hObject==handles.button_form_functions
    guidata(hObject,handles);
    return
end

set(handles.text_build_mesh,'String','O','ForegroundColor','black');
if hObject==handles.button_mesh || hObject==handles.button_batch
    guidata(hObject,handles);
    return
end

set(handles.radio_save_orig_nodes,'Value',0.0);
set(handles.radio_save_orig_facets,'Value',0.0);
set(handles.radio_save_fin_nodes,'Value',0.0);
set(handles.radio_save_fin_facets,'Value',0.0);
set(handles.radio_save_matrix,'Value',0.0);
set(handles.radio_save_charges,'Value',0.0);
set(handles.radio_save_results,'Value',0.0);
set(handles.radio_save_caps,'Value',0.0);

set(handles.table_beam_param,'Data',[100e-6 1e-6 0.5e-6 10 2 2 1e-6; 100e-6 10e-6 0.5e-6 10 4 2 15e-6]);


% Clear some large variables
handles.P=0;
handles.facet_centers=0;
handles.facet_areas=0;
handles.node_list=0;
handles.facet_list=0;
handles.node1_list=0;
handles.facet1_list=0;
handles.node2_list=0;
handles.facet2_list=0;
handles.sigma1=0;
handles.sigma2=0;

set(handles.button_options,'ForegroundColor','black');
handles.custom_field_radii=0; % Automatic far and close field radius calculation
calculate_radii(hObject,handles);
handles=guidata(hObject);


handles.batch_mode_on=0; % Not in a batch mode
set(handles.button_batch,'ForegroundColor','black');

guidata(hObject,handles);

% --- Executes on button press in radio_save_orig_nodes.
function radio_save_orig_nodes_Callback(hObject, eventdata, handles)
% hObject    handle to radio_save_orig_nodes (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Hint: get(hObject,'Value') returns toggle state of radio_save_orig_nodes

% --- Executes on button press in radio_save_fin_nodes.
function radio_save_fin_nodes_Callback(hObject, eventdata, handles)
% hObject    handle to radio_save_fin_nodes (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Hint: get(hObject,'Value') returns toggle state of radio_save_fin_nodes

% --- Executes on button press in radio_save_orig_facets.
function radio_save_orig_facets_Callback(hObject, eventdata, handles)
% hObject    handle to radio_save_orig_facets (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Hint: get(hObject,'Value') returns toggle state of radio_save_orig_facets

% --- Executes on button press in radio_save_fin_facets.
function radio_save_fin_facets_Callback(hObject, eventdata, handles)
% hObject    handle to radio_save_fin_facets (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Hint: get(hObject,'Value') returns toggle state of radio_save_fin_facets

% --- Executes on button press in radio_save_matrix.
function radio_save_matrix_Callback(hObject, eventdata, handles)
% hObject    handle to radio_save_matrix (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Hint: get(hObject,'Value') returns toggle state of radio_save_matrix

% --- Executes on button press in radio_save_charges.
function radio_save_charges_Callback(hObject, eventdata, handles)
% hObject    handle to radio_save_charges (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Hint: get(hObject,'Value') returns toggle state of radio_save_charges

% --- Executes on button press in radio_save_results.
function radio_save_results_Callback(hObject, eventdata, handles)
% hObject    handle to radio_save_results (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Hint: get(hObject,'Value') returns toggle state of radio_save_results

% --- Executes on button press in radio_save_caps.
function radio_save_caps_Callback(hObject, eventdata, handles)
% hObject    handle to radio_save_caps (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Hint: get(hObject,'Value') returns toggle state of radio_save_caps

% --- Executes on button press in button_close.
function button_close_Callback(hObject, eventdata, handles)
% hObject    handle to button_close (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
user_response=questdlg('Confirm Close','Closing . . .','Yes','No','No');
switch user_response
    case {'No'}
        % take no action
    case 'Yes'
        button_reset_Callback(hObject, eventdata, handles);
		handles=guidata(hObject);
        delete(handles.figure1)
end

% --------------------------------------------------------------------
function table_beam_param_ButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to table_beam_param (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --- Executes when entered data in editable cell(s) in table_beam_param.
function table_beam_param_CellEditCallback(hObject, eventdata, handles)
% hObject    handle to table_beam_param (see GCBO)
% eventdata  structure with the following fields (see UITABLE)
%	Indices: row and column indices of the cell(s) edited
%	PreviousData: previous data for the cell(s) edited
%	EditData: string(s) entered by the user
%	NewData: EditData or its converted form set on the Data property. Empty if Data was not changed
%	Error: error string when failed to convert EditData to appropriate value for Data
% handles    structure with handles and user data (see GUIDATA)

temp=get(handles.text_build_mesh,'String');
if strcmp(temp,'V') % Previous extraction data exists
    user_response=questdlg('Editing this table will invalidate all existent extraction data. Continue?','Warning','Yes','No','No');
    switch user_response
        case {'No'}
            % Restore the original data
            temp=get(hObject,'Data');
            for k=1:size(eventdata.Indices,1) % for all editions
                temp(eventdata.Indices(k,1),eventdata.Indices(k,2))=eventdata.PreviousData(k); % Restore original
            end
            set(hObject,'Data',temp);
            return;
        case ('Yes')
            % take no action
    end
end

% Recalculate the close-field and far-field radii
if ~handles.custom_field_radii % If custom radii are not defined
    calculate_radii(hObject,handles);
    handles=guidata(hObject);
end

% Reset all data
set(handles.text_build_mesh,'String','O','ForegroundColor','black');
set(handles.text_apply_form_function,'String','O','ForegroundColor','black');
set(handles.text_build_matrix,'String','O','ForegroundColor','black');
set(handles.text_charges,'String','O','ForegroundColor','black');
set(handles.text_caps,'String','O','ForegroundColor','black');

set(handles.text_C11,'String','C11');
set(handles.text_C12,'String','C12');
set(handles.text_C21,'String','C21');
set(handles.text_C22,'String','C22');
set(handles.text_C10,'String','C10');
set(handles.text_C20,'String','C20');
set(handles.text_error,'String','diff(C12,C21)/mean(C12,C21)');

cla(handles.main_axes,'reset'); % Reset the main axes

guidata(hObject,handles);

function calculate_radii(hObject,handles) % Default close-field and far-field radius calculation
temp=get(handles.table_beam_param,'Data');

handles.close_field_radius=2*max(max(temp(:,1:3)./temp(:,4:6)));
handles.far_field_radius=30*max(max(temp(:,1:3)./temp(:,4:6)));
guidata(hObject,handles);

% --- Executes on button press in button_batch.
function button_batch_Callback(hObject, eventdata, handles)
% hObject    handle to button_batch (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if handles.batch_mode_on ~= 0 % Batch mode is already on
    set(handles.button_batch,'String','Stopping','ForegroundColor','red'); % Abort the batch run
    guidata(hObject,handles);
    return;
end


temp=get(handles.table_beam_param,'Data');

prompt = {'First form function parameter vector','Second form function parameter vector'};
dlg_title = 'Sweep parameters';
num_lines = 1;
def = {num2str(temp(1,7)),num2str(temp(2,7))};
answer = inputdlg(prompt,dlg_title,num_lines,def);

if isempty(answer) % Cancel
    return;
end

param1=str2num(answer{1});
param2=str2num(answer{2});

if size(param1,1)~=1 || size(param2,1)~=1 % The sweep parameters are not one-dimensional arrays
    errordlg('Sweep parameters should be horizontal vectors','Input Error');
    return;
end

handles.batch_mode_on=1; % Set flag for batch mode running
set(handles.button_batch,'ForegroundColor','green','String','Press to stop');

buttons=[handles.button_mesh handles.button_form_functions handles.button_matrix handles.button_charges handles.button_capacitances];

% Disable all buttons
for i=1:length(buttons)
    set(buttons(i),'Enable','off');
end
set(handles.table_beam_param,'Enable','off');
set(handles.button_reset,'Enable','off');
set(handles.button_options,'Enable','off');

guidata(hObject,handles);

temp=get(handles.table_beam_param,'Data');

f=fopen('batch_results.txt','wt'); % Open saving file
fprintf(f,'Beam parameters:\nl\tt\tw\n%g\t%g\t%g\n%g\t%g\t%g\n\n',temp(:,1:3)');
fprintf(f,'Mesh parameters:\nNl\tNt\tNw\n%g\t%g\t%g\n%g\t%g\t%g\n\n',temp(:,4:6)');
fprintf(f,'param1\tparam2\tC11(F)\tC22(F)\tC12_avg(F)\tC10(F)\tC20(F)\tC_error(%%)\n');

for i=1:length(param1) % For all values of param1
    temp(1,7)=param1(i);
    for j=1:length(param2) % For all values of param2
        temp(2,7)=param2(j);
        set(handles.table_beam_param,'Data',temp); % Update the beam parameter table
        for k=1:length(buttons) % "Press" all extraction buttons one after another
            if strcmp(get(handles.button_batch,'String'),'Stopping') % Abort the run
                break;
            end
            func_handle=get(buttons(k),'Callback');
            func_handle(buttons(k),eventdata);
            handles=guidata(hObject);
            drawnow;
        end
        if strcmp(get(handles.button_batch,'String'),'Stopping') % Abort the run
            break;
        end
        fprintf(f,'%g\t%g\t%g\t%g\t%g\t%g\t%g\t%g\n',param1(i),param2(j),handles.C11,handles.C22,handles.C12_avg,handles.C10,handles.C20,handles.C_error);
    end
    if strcmp(get(handles.button_batch,'String'),'Stopping') % Abort the run
        break;
    end
end

switch get(handles.button_batch,'String') % Check whether the run was aborted
    case 'Press to stop' % Normal stop
        fclose(f);
        msgbox('Batch mode finished. Results saved in "batch_results.txt"','Notification');
    case 'Stopping' % Abort
        fprintf(f,'\nBatch run aborted.');
        fclose(f);
        msgbox('Batch mode aborted. Available results saved in "batch_results.txt"','Notification');
end

% Return to normal mode

handles.batch_mode_on=0; % Set flag for batch mode running
set(handles.button_batch,'ForegroundColor','black','String','Batch Mode');

% Enable all buttons back
for i=1:length(buttons)
    set(buttons(i),'Enable','on');
end
set(handles.table_beam_param,'Enable','on');
set(handles.button_reset,'Enable','on');
set(handles.button_options,'Enable','on');

button_reset_Callback(hObject, eventdata, handles);
handles=guidata(hObject);

guidata(hObject,handles);


% --- Executes on button press in button_options.
function button_options_Callback(hObject, eventdata, handles)
% hObject    handle to button_options (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

temp=get(handles.text_build_matrix,'String');
if strcmp(temp,'V') % Matrix already exists
    user_response=questdlg('Editing solver options will invalidate matrix extraction data. Continue?','Warning','Yes','No','No');
    switch user_response
        case {'No'}
            return;
        case ('Yes')
            button_reset_Callback(handles.button_matrix, eventdata, handles); % Reset relevant data         
			handles=guidata(hObject);
    end
end

% Read custom close & far field radii
prompt = {'Close field radius','Far field radius'};
dlg_title = 'Solver options';
num_lines = 1;
def = {num2str(handles.close_field_radius),num2str(handles.far_field_radius)};
answer = inputdlg(prompt,dlg_title,num_lines,def);
if ~isempty(answer) % New input
    handles.close_field_radius=str2num(answer{1});
    handles.far_field_radius=str2num(answer{2});
    handles.custom_field_radii=1; % Set flag for custom far and close field radii
    set(handles.button_options,'ForegroundColor','green');
end


guidata(hObject,handles);


% --- Executes on button press in button_detach_fig.
function button_detach_fig_Callback(hObject, eventdata, handles)
% hObject    handle to button_detach_fig (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

f=figure; % Standalone figure
a=copyobj(handles.main_axes,f);  % Copy the axes
set(a,'Units','normalized','Position',[0.2 0.2 0.7 0.7]); % Resize the axes to fit the new figure

