function sandmap = figdesign(gca,gcf,p)

whitebg black
camlight headlight
lighting gouraud
shading interp
rotate3d on
axis on
box on
grid off

set(gca,'BoxStyle','full')
set(gca,'xtick',[])
set(gca,'ytick',[])
set(gca,'ztick',[])

limits = ones(1,2);
limits(1) = -max(p.h(:));
set(gca,'xlim',[-p.meshSize/2 p.meshSize/2-1])
set(gca,'ylim',[-p.meshSize/2 p.meshSize/2-1])
set(gca,'zlim',limits)

set(gcf,'menubar','none')
set(gcf,'toolbar','none')

scm = flipud(colormap(summer)); % summer colormap for seafloor

sandmap(1,:,1) = spline(linspace(0,1,64),scm(:,1),linspace(0,1,p.meshSize));
sandmap(1,:,2) = spline(linspace(0,1,64),scm(:,2),linspace(0,1,p.meshSize));
sandmap(1,:,3) = spline(linspace(0,1,64),scm(:,3),linspace(0,1,p.meshSize));

for m = 2:p.meshSize
    sandmap(m,:,:) = sandmap(1,:,:);
end