function seaFloor = generate_seafloor(p,shore)

seaFloor = zeros(p.meshSize); 
base = zeros(p.meshSize, p.meshSize/2); 

stepSize = p.meshSize/p.femSteps;
check = 1;
while check %build proper step marks
    steps = stepSize *(1:p.femSteps) + [round(p.femVar * stepSize * randn(1,p.femSteps-1)),0];
    halfSteps = stepSize *(1:p.femSteps/2) + [round(p.femVar * stepSize * randn(1,p.femSteps/2-1)),0];
    if steps(1) > 0 && min(sort(steps)==steps) && halfSteps(1) > 0 && min(sort(halfSteps)==halfSteps)
        check = 0;
    end
end

for m = 1:p.femSteps
    for n = 1:steps(m)
        seaFloor(:,n) = seaFloor(:,n) + 1;
    end
end
seaFloor = seaFloor/max(abs(seaFloor(:))) - 2;

if shore
    for m = 1:p.femSteps/2
        for n = 1:halfSteps(m)
            base(:,n) = base(:,n) + 1;
        end
    end
    base = base/max(abs(base(:)));

    if shore == 2
        steps = [1,steps];
        for m = 1:p.femSteps
            shift = randn;
            for n = steps(m):steps(m+1)
                base(n,:) = (1+(p.femVar^2)*shift)*base(n,:);
            end
        end
    end

    half = base(:,1:p.meshSize/4);
    seaFloor = [half, fliplr(half), base] -2;
end