function [shock_map, after_shock] = shock_boundary(p, Ht, prev_shock)

if ~max(prev_shock) % first frame chase
    if max(Ht(:,end)) <= 0 % don't start for no peak
        shock_map = prev_shock;
        after_shock = 0;
        return
    end
end

shock_map = [prev_shock, ones(p.meshSize,1)]; % add sholder to cut later for first loop iteration

for i = 1:p.meshSize
    for j = p.meshSize:-1:1
        if Ht(i,j)>0 && shock_map(i,j+1)
            shock_map(i,j) = 1;
        end
    end
end

shock_map(:,end) = []; % cut sholder

loc_vec = p.meshSize* ones(1,p.meshSize); % shock location vector
for i = 1:p.meshSize
    for j = p.meshSize:-1:1
        if shock_map(i,j)
            loc_vec(i) = j;
        end
    end
end

mean_loc = mean(loc_vec);
mean_ret = mean(loc_vec(loc_vec>mean_loc));
collect = round(mean_ret); %colect all retarded pixels

if collect > 0
    for j = p.meshSize:-1:collect
        shock_map(:,j) = ones(p.meshSize,1);
        after_shock = 0;
    end
else
    after_shock = 1;
end