function [S,k] = generate_wave_spectrum(p)

S = zeros(p.meshSize,p.meshSize);
k = zeros(p.meshSize,p.meshSize);

for m = 1:p.meshSize
    for n = 1:p.meshSize
        kx = 2*pi*(m-1-p.meshSize/2)/p.fftRes;
        ky = 2*pi*(n-1-p.meshSize/2)/p.fftRes;
        k2 = kx*kx + ky*ky;
        k(m,n) = sqrt(k2);
        wind_dot_k = -ky/sqrt(k2);
        
        exp_arg = (k(m,n)*(p.V^2)/p.g)^(-2);
        S(m,n) = p.A *exp(-exp_arg) *(k(m,n)^(-4)) *(wind_dot_k^2) *exp(-(k(m,n)^2)*p.waveLimit^2);
        
        if(wind_dot_k<0) % use wind to dump reversed waves
            S(m,n) = S(m,n) * p.windDamp;
        end
        
        if(kx == 0 && ky == 0)
            S(m,n) = 0;
        end
    end
end

end