function p = set_parameters
% pay attention!
%   p.A, p.meshSize and p.femSteps
% are run over in set_gpu_parameters

p = struct;

p.V = 14; % wind speed [m/s]  ( 2*p.V = wind speed [knots] )
p.A = 164; % amplitude a.u.
p.g = 9.81; % gravitational constant
p.windDamp = .02; % wind attenuation
p.frameRate = 25; % Hz (for animation)

p.meshSize = 128; % playground size
p.femSteps = 16; % Finite elements method partiotion steps (use powers of 4)
p.femVar = .4; % partiotion variance (use <1)
p.fftRes = 64;  % fft resolution
p.waveLimit = 1.2; % lowpass for waves

p.saveVid = 0; % save animation as video file
p.fileName = 'movie'; % video file name

end