(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     24596,        698]
NotebookOptionsPosition[     24303,        684]
NotebookOutlinePosition[     24646,        699]
CellTagsIndexPosition[     24603,        696]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"g", "=", "9.81"}], ";", 
   RowBox[{"m", "=", "1"}], ";", 
   RowBox[{"A", "=", 
    RowBox[{"Abs", "[", 
     RowBox[{
      FractionBox[
       RowBox[{"-", "5"}], "2"], "+", "0.2"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Garrow", "=", 
    RowBox[{"Graphics3D", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Text", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{"\"\<g\>\"", ",", "Large", ",", "Bold", ",", "Red"}], "]"}],
          ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "2.5"}], ",", "2", ",", "1.75"}], "}"}]}], "]"}], ",",
        "Red", ",", 
       RowBox[{"Arrowheads", "[", "0.05", "]"}], ",", 
       RowBox[{"Arrow", "[", 
        RowBox[{"Tube", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "3"}], ",", "2", ",", "5"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "3"}], ",", "2", ",", "1.5"}], "}"}]}], "}"}], ",",
           "0.05"}], "]"}], "]"}]}], "}"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Road", "[", "curve_", "]"}], ":=", 
    RowBox[{"ParametricPlot3D", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"2", 
         RowBox[{"(", 
          RowBox[{"1", "+", "t"}], ")"}], 
         RowBox[{"Sin", "[", "x", "]"}]}], ",", 
        RowBox[{
         RowBox[{"2", 
          RowBox[{"(", 
           RowBox[{"1", "+", "t"}], ")"}], 
          RowBox[{"Cos", "[", "x", "]"}]}], "+", "2"}], ",", 
        RowBox[{
         RowBox[{"Tan", "[", 
          RowBox[{"curve", " ", 
           FractionBox["\[Pi]", "180"]}], "]"}], 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"t", "*", "2"}], "-", 
           RowBox[{"2", "*", "1.25"}]}], ")"}]}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", 
        FractionBox[
         RowBox[{"-", "\[Pi]"}], "2"], ",", "\[Pi]"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"t", ",", "0.75", ",", "1.75"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Launcher", "[", 
     RowBox[{"time_", ",", "v_"}], "]"}], ":=", "\[IndentingNewLine]", 
    RowBox[{"Graphics3D", "[", 
     RowBox[{"{", 
      RowBox[{"Black", ",", 
       RowBox[{"Cuboid", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "4"}], ",", 
            FractionBox[
             RowBox[{"-", "11"}], "4"], ",", 
            FractionBox[
             RowBox[{"-", "1"}], "4"]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "3"}], ",", 
            FractionBox[
             RowBox[{"-", "7"}], "4"], ",", 
            FractionBox["3", "4"]}], "}"}]}], "}"}], "]"}], 
       RowBox[{"(*", "BOX", "*)"}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", "Red", ",", 
       RowBox[{"Cylinder", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"time", "<=", 
                RowBox[{
                 FractionBox["\[Pi]", "2"], 
                 FractionBox["A", "v"]}]}], ",", 
               RowBox[{
                RowBox[{"-", "A"}], "*", 
                RowBox[{"Cos", "[", 
                 RowBox[{
                  FractionBox["v", "A"], "*", "time"}], "]"}]}], ",", "0"}], 
              "]"}], ",", 
             FractionBox[
              RowBox[{"-", "9"}], "4"], ",", 
             FractionBox["1", "4"]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"time", "<=", 
                RowBox[{
                 FractionBox["\[Pi]", "2"], 
                 FractionBox["A", "v"]}]}], ",", 
               RowBox[{"0.2", "-", 
                RowBox[{"A", "*", 
                 RowBox[{"Cos", "[", 
                  RowBox[{
                   FractionBox["v", "A"], "*", "time"}], "]"}]}]}], ",", 
               "0.2"}], "]"}], ",", 
             FractionBox[
              RowBox[{"-", "9"}], "4"], ",", 
             FractionBox["1", "4"]}], "}"}]}], "}"}], ",", 
         FractionBox["1", "2"]}], "]"}]}], "}"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Spring", "[", 
     RowBox[{"time_", ",", "v_"}], "]"}], ":=", 
    RowBox[{"ParametricPlot3D", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"time", "<", 
              RowBox[{
               FractionBox["\[Pi]", "2"], 
               FractionBox["A", "v"]}]}], ",", 
             RowBox[{"3", "-", 
              RowBox[{"A", "*", 
               RowBox[{"Cos", "[", 
                RowBox[{
                 FractionBox["v", "A"], "*", "time"}], "]"}]}]}], ",", "3"}], 
            "]"}], ")"}], "*", 
          FractionBox["t", 
           RowBox[{"6", "\[Pi]"}]]}], "-", "3"}], ",", 
        RowBox[{
         RowBox[{
          FractionBox["1", "3"], 
          RowBox[{"Cos", "[", "t", "]"}]}], "-", 
         FractionBox["9", "4"]}], ",", 
        RowBox[{
         RowBox[{
          FractionBox["1", "3"], 
          RowBox[{"Sin", "[", "t", "]"}]}], "+", 
         FractionBox["1", "4"]}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"t", ",", "0", ",", 
        RowBox[{"6", "\[Pi]"}]}], "}"}], ",", 
      RowBox[{"PlotStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Gray", ",", 
         RowBox[{"Thickness", "[", "0.005", "]"}]}], "}"}]}]}], "]"}]}], 
   ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"R", "[", 
    RowBox[{"time_", ",", "curve_", ",", "v_"}], "]"}], ":=", 
   RowBox[{"1.25", " ", "+", 
    RowBox[{
     FractionBox["1", "2"], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        FractionBox[
         SuperscriptBox["v", "2"], "1.25"], 
        RowBox[{"Cos", "[", 
         RowBox[{"curve", 
          FractionBox["\[Pi]", "180"]}], "]"}]}], "-", 
       RowBox[{"g", "*", 
        RowBox[{"Sin", "[", 
         RowBox[{"curve", 
          FractionBox["\[Pi]", "180"]}], "]"}]}]}], ")"}], "*", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"time", "-", 
        FractionBox[
         RowBox[{"ArcCos", "[", 
          FractionBox["2", 
           RowBox[{"5", "A"}]], "]"}], 
         FractionBox["v", "A"]]}], ")"}], "2"]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ballfirmovment", "[", 
    RowBox[{"time_", ",", "curve_", ",", "v_"}], "]"}], ":=", 
   RowBox[{"Graphics3D", "[", 
    RowBox[{"{", 
     RowBox[{"Blue", ",", 
      RowBox[{"Sphere", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", 
          RowBox[{
           FractionBox[
            RowBox[{"-", "5"}], "2"], "+", 
           RowBox[{
            FractionBox["1", "5"], 
            RowBox[{"Sin", "[", 
             RowBox[{"curve", 
              FractionBox["\[Pi]", "180"]}], "]"}]}]}], ",", 
          RowBox[{
           FractionBox["1", "5"], 
           RowBox[{"Cos", "[", 
            RowBox[{"curve", 
             FractionBox["\[Pi]", "180"]}], "]"}]}]}], "}"}], ",", 
        FractionBox["1", "5"]}], "]"}]}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ballsecmovment", "[", 
     RowBox[{"time_", ",", "curve_", ",", "v_"}], "]"}], ":=", 
    RowBox[{"Graphics3D", "[", 
     RowBox[{"{", 
      RowBox[{"Blue", ",", 
       RowBox[{"Sphere", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"2", 
             RowBox[{"(", 
              RowBox[{"1", "+", 
               RowBox[{"R", "[", 
                RowBox[{"time", ",", "curve", ",", "v"}], "]"}]}], ")"}], 
             RowBox[{"Sin", "[", 
              RowBox[{
               FractionBox["v", 
                RowBox[{"R", "[", 
                 RowBox[{"time", ",", "curve", ",", "v"}], "]"}]], 
               RowBox[{"(", 
                RowBox[{"time", "-", 
                 FractionBox[
                  RowBox[{"ArcCos", "[", 
                   FractionBox["2", 
                    RowBox[{"5", "A"}]], "]"}], 
                  FractionBox["v", "A"]]}], ")"}]}], "]"}]}], "-", 
            RowBox[{
             FractionBox["1", "5"], 
             RowBox[{"Sin", "[", 
              RowBox[{"curve", 
               FractionBox["\[Pi]", "180"]}], "]"}], 
             RowBox[{"Sin", "[", 
              RowBox[{
               FractionBox["v", 
                RowBox[{"R", "[", 
                 RowBox[{"time", ",", "curve", ",", "v"}], "]"}]], 
               RowBox[{"(", 
                RowBox[{"time", "-", 
                 FractionBox[
                  RowBox[{"ArcCos", "[", 
                   FractionBox["2", 
                    RowBox[{"5", "A"}]], "]"}], 
                  FractionBox["v", "A"]]}], ")"}]}], "]"}]}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "2"}], 
             RowBox[{"(", 
              RowBox[{"1", "+", 
               RowBox[{"R", "[", 
                RowBox[{"time", ",", "curve", ",", "v"}], "]"}]}], ")"}], 
             RowBox[{"Cos", "[", 
              RowBox[{
               FractionBox["v", 
                RowBox[{"R", "[", 
                 RowBox[{"time", ",", "curve", ",", "v"}], "]"}]], 
               RowBox[{"(", 
                RowBox[{"time", "-", 
                 FractionBox[
                  RowBox[{"ArcCos", "[", 
                   FractionBox["2", 
                    RowBox[{"5", "A"}]], "]"}], 
                  FractionBox["v", "A"]]}], ")"}]}], "]"}]}], "+", "2", "+", 
            RowBox[{
             FractionBox["1", "5"], 
             RowBox[{"Sin", "[", 
              RowBox[{"curve", 
               FractionBox["\[Pi]", "180"]}], "]"}], 
             RowBox[{"Cos", "[", 
              RowBox[{
               FractionBox["v", 
                RowBox[{"R", "[", 
                 RowBox[{"time", ",", "curve", ",", "v"}], "]"}]], 
               RowBox[{"(", 
                RowBox[{"time", "-", 
                 FractionBox[
                  RowBox[{"ArcCos", "[", 
                   FractionBox["2", 
                    RowBox[{"5", "A"}]], "]"}], 
                  FractionBox["v", "A"]]}], ")"}]}], "]"}]}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"R", "[", 
                RowBox[{"time", ",", "curve", ",", "v"}], "]"}], "-", 
               "1.25"}], ")"}], "*", 
             RowBox[{"Tan", "[", 
              RowBox[{"curve", " ", 
               FractionBox["\[Pi]", "180"]}], "]"}]}], "+", 
            RowBox[{
             FractionBox["1", "5"], 
             RowBox[{"Cos", "[", 
              RowBox[{"curve", 
               FractionBox["\[Pi]", "180"]}], "]"}]}]}]}], "}"}], 
         "\[IndentingNewLine]", ",", 
         FractionBox["1", "5"]}], "]"}]}], "}"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ball", "[", 
     RowBox[{"time_", ",", "curve_", ",", "v_"}], "]"}], ":=", 
    "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"time", "<", 
       FractionBox[
        RowBox[{"ArcCos", "[", 
         FractionBox["2", 
          RowBox[{"5", "A"}]], "]"}], 
        FractionBox["v", "A"]]}], ",", 
      RowBox[{"ballfirmovment", "[", 
       RowBox[{"time", ",", "curve", ",", "v"}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"R", "[", 
           RowBox[{"time", ",", "curve", ",", "v"}], "]"}], ">=", "0.75"}], "&&",
          " ", 
         RowBox[{
          RowBox[{"R", "[", 
           RowBox[{"time", ",", "curve", ",", "v"}], "]"}], "\[LessEqual]", 
          "1.75"}], " ", "&&", " ", 
         RowBox[{
          RowBox[{
           FractionBox["v", 
            RowBox[{"R", "[", 
             RowBox[{"time", ",", "curve", ",", "v"}], "]"}]], 
           RowBox[{"(", 
            RowBox[{"time", "-", 
             FractionBox[
              RowBox[{"ArcCos", "[", 
               FractionBox["2", 
                RowBox[{"5", "A"}]], "]"}], 
              FractionBox["v", "A"]]}], ")"}]}], ">=", 
          RowBox[{"3", 
           FractionBox["\[Pi]", "2"]}]}]}], " ", ",", "\[IndentingNewLine]", 
        "\t", 
        RowBox[{"Graphics3D", "[", 
         RowBox[{"Text", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{"\"\<Good\>\"", ",", "45", ",", "Bold", ",", "Black"}], 
            "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", "3"}], "}"}]}], "]"}], "]"}], ",", 
        "\[IndentingNewLine]", "\t", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"R", "[", 
            RowBox[{"time", ",", "curve", ",", "v"}], "]"}], "<=", "0.75"}], 
          " ", ",", "\[IndentingNewLine]", "\t\t", 
          RowBox[{"Graphics3D", "[", 
           RowBox[{"Text", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{
              "\"\<Too slow/ angle in too Big\>\"", ",", "30", ",", "Bold", 
               ",", "Black"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", "0", ",", "3"}], "}"}]}], "]"}], "]"}], ",", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", "\t\t", 
          RowBox[{"If", "[", " ", 
           RowBox[{
            RowBox[{
             RowBox[{"R", "[", 
              RowBox[{"time", ",", "curve", ",", "v"}], "]"}], ">=", "1.75"}],
             " ", ",", "\[IndentingNewLine]", "\t\t\t", 
            RowBox[{"Graphics3D", "[", 
             RowBox[{"Text", "[", 
              RowBox[{
               RowBox[{"Style", "[", 
                RowBox[{
                "\"\<Too fast/ angle in too small\>\"", ",", "30", ",", 
                 "Bold", ",", "Black"}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"0", ",", "0", ",", "3"}], "}"}]}], "]"}], "]"}], ",",
             "\[IndentingNewLine]", "\[IndentingNewLine]", "\t\t", 
            RowBox[{"ballsecmovment", "[", 
             RowBox[{"time", ",", "curve", ",", "v"}], "]"}]}], 
           "\[IndentingNewLine]", "\t", "\[IndentingNewLine]", "]"}]}], 
         "]"}]}], "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"balltrack", "[", 
     RowBox[{"curve_", ",", "time_", ",", "v_"}], "]"}], ":=", 
    RowBox[{"ParametricPlot3D", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"2", 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            RowBox[{"R", "[", 
             RowBox[{"t", ",", "curve", ",", "v"}], "]"}]}], ")"}], 
          RowBox[{"Sin", "[", 
           RowBox[{
            FractionBox["v", 
             RowBox[{"R", "[", 
              RowBox[{"t", ",", "curve", ",", "v"}], "]"}]], 
            RowBox[{"(", 
             RowBox[{"t", "-", 
              FractionBox[
               RowBox[{"ArcCos", "[", 
                FractionBox["2", 
                 RowBox[{"5", "A"}]], "]"}], 
               FractionBox["v", "A"]]}], ")"}]}], "]"}]}], "-", 
         RowBox[{
          FractionBox["1", "5"], 
          RowBox[{"Sin", "[", 
           RowBox[{"curve", 
            FractionBox["\[Pi]", "180"]}], "]"}], 
          RowBox[{"Sin", "[", 
           RowBox[{
            FractionBox["v", 
             RowBox[{"R", "[", 
              RowBox[{"t", ",", "curve", ",", "v"}], "]"}]], 
            RowBox[{"(", 
             RowBox[{"t", "-", 
              FractionBox[
               RowBox[{"ArcCos", "[", 
                FractionBox["2", 
                 RowBox[{"5", "A"}]], "]"}], 
               FractionBox["v", "A"]]}], ")"}]}], "]"}]}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "2"}], 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            RowBox[{"R", "[", 
             RowBox[{"t", ",", "curve", ",", "v"}], "]"}]}], ")"}], 
          RowBox[{"Cos", "[", 
           RowBox[{
            FractionBox["v", 
             RowBox[{"R", "[", 
              RowBox[{"t", ",", "curve", ",", "v"}], "]"}]], 
            RowBox[{"(", 
             RowBox[{"t", "-", 
              FractionBox[
               RowBox[{"ArcCos", "[", 
                FractionBox["2", 
                 RowBox[{"5", "A"}]], "]"}], 
               FractionBox["v", "A"]]}], ")"}]}], "]"}]}], "+", "2", "+", 
         RowBox[{
          FractionBox["1", "5"], 
          RowBox[{"Sin", "[", 
           RowBox[{"t", 
            FractionBox["\[Pi]", "180"]}], "]"}], 
          RowBox[{"Cos", "[", 
           RowBox[{
            FractionBox["v", 
             RowBox[{"R", "[", 
              RowBox[{"t", ",", "curve", ",", "v"}], "]"}]], 
            RowBox[{"(", 
             RowBox[{"t", "-", 
              FractionBox[
               RowBox[{"ArcCos", "[", 
                FractionBox["2", 
                 RowBox[{"5", "A"}]], "]"}], 
               FractionBox["v", "A"]]}], ")"}]}], "]"}]}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"R", "[", 
             RowBox[{"t", ",", "curve", ",", "v"}], "]"}], "-", "1.25"}], 
           ")"}], "*", 
          RowBox[{"Tan", "[", 
           RowBox[{"curve", " ", 
            FractionBox["\[Pi]", "180"]}], "]"}]}], "+", 
         RowBox[{
          FractionBox["1", "5"], 
          RowBox[{"Cos", "[", 
           RowBox[{"curve", 
            FractionBox["\[Pi]", "180"]}], "]"}]}]}]}], "}"}], 
      "\[IndentingNewLine]", ",", 
      RowBox[{"{", 
       RowBox[{"t", ",", 
        FractionBox[
         RowBox[{"ArcCos", "[", 
          FractionBox["2", 
           RowBox[{"5", "A"}]], "]"}], 
         FractionBox["v", "A"]], ",", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"R", "[", 
            RowBox[{"time", ",", "curve", ",", "v"}], "]"}], "<=", "0.05"}], 
          ",", 
          RowBox[{
           FractionBox["1", 
            RowBox[{"v", "+", "1"}]], "+", 
           FractionBox[
            RowBox[{"ArcCos", "[", 
             FractionBox["2", 
              RowBox[{"5", "A"}]], "]"}], 
            FractionBox["v", "A"]]}], ",", 
          RowBox[{
           FractionBox[
            RowBox[{"\[Pi]", "*", "2"}], "v"], "+", 
           FractionBox[
            RowBox[{"ArcCos", "[", 
             FractionBox["2", 
              RowBox[{"5", "A"}]], "]"}], 
            FractionBox["v", "A"]]}]}], "]"}]}], "}"}], ",", 
      RowBox[{"PlotStyle", "\[Rule]", "Red"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Manipulate", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Show", "[", "\[IndentingNewLine]", 
    RowBox[{"Garrow", ",", 
     RowBox[{"Road", "[", "curve", "]"}], ",", 
     RowBox[{"Launcher", "[", 
      RowBox[{"time", ",", "v"}], "]"}], ",", 
     RowBox[{"Spring", "[", 
      RowBox[{"time", ",", "v"}], "]"}], ",", 
     RowBox[{"ball", "[", 
      RowBox[{"time", ",", "curve", ",", "v"}], "]"}], ",", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"balltrack", "[", 
        RowBox[{"curve", ",", "time", ",", "v"}], "]"}], ","}], "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "6"}], ",", "6"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "4"}], ",", "8"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "2"}], ",", "5"}], "}"}]}], "}"}]}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "550"}], ",", 
     RowBox[{"Boxed", "\[Rule]", "False"}]}], "]"}], ",", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"Row", "[", 
    RowBox[{"{", 
     RowBox[{"Style", "[", 
      RowBox[{"\"\<Inital conditions:\>\"", ",", "20", ",", "Bold"}], "]"}], 
     "}"}], "]"}], ",", "\[IndentingNewLine]", 
   RowBox[{"Row", "[", 
    RowBox[{"{", 
     RowBox[{"\"\<Angle \>\"", ",", 
      RowBox[{"Style", "[", 
       RowBox[{"\"\<   \[Theta] \>\"", ",", " ", "Italic"}], "]"}], ",", " ", 
      RowBox[{"Control", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"curve", ",", "13.3", ",", "\"\<\>\""}], "}"}], ",", "0.01",
          ",", "80", ",", "1", ",", 
         RowBox[{"Appearance", "\[Rule]", "\"\<Labeled\>\""}], ",", 
         RowBox[{"ImageSize", "\[Rule]", "Tiny"}]}], "}"}], "]"}], ",", 
      "\[IndentingNewLine]", "\"\<Velocity \>\"", ",", 
      RowBox[{"Style", "[", 
       RowBox[{"\"\<V \>\"", ",", " ", "Italic"}], "]"}], ",", " ", 
      RowBox[{"Control", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"v", ",", "1.7", ",", "\"\<\>\""}], "}"}], ",", "0.1", ",", 
         "5", ",", "0.1", ",", 
         RowBox[{"Appearance", "\[Rule]", "\"\<Labeled\>\""}], ",", 
         RowBox[{"ImageSize", "\[Rule]", "Tiny"}]}], "}"}], "]"}]}], "}"}], 
    "]"}], ",", "\[IndentingNewLine]", 
   RowBox[{"Row", "[", 
    RowBox[{"{", 
     RowBox[{"Style", "[", 
      RowBox[{"\"\< \>\"", ",", "20"}], "]"}], "}"}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"Row", "[", 
    RowBox[{"{", 
     RowBox[{"Style", "[", 
      RowBox[{"\"\<Evolution in time: \>\"", ",", "20", ",", "Bold"}], "]"}], 
     "}"}], "]"}], ",", "\[IndentingNewLine]", 
   RowBox[{"Row", "[", 
    RowBox[{"{", 
     RowBox[{"Style", "[", 
      RowBox[{"\"\< \>\"", ",", "20"}], "]"}], "}"}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"Row", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Style", "[", 
       RowBox[{"\"\<Time t in Sec\>\"", ",", "20"}], "]"}], ",", "  ", 
      RowBox[{"Control", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"time", ",", "0", ",", "\"\<\>\""}], "}"}], ",", "0", ",", 
         RowBox[{
          FractionBox[
           RowBox[{"\[Pi]", "*", "2"}], "v"], "+", 
          FractionBox[
           RowBox[{"ArcCos", "[", 
            FractionBox["2", 
             RowBox[{"5", "A"}]], "]"}], 
           FractionBox["v", "A"]]}], ",", "0.001", ",", 
         RowBox[{"Appearance", "\[Rule]", "\"\<Labeled\>\""}], ",", 
         RowBox[{"ImageSize", "\[Rule]", "Large"}]}], "}"}], "]"}]}], "}"}], 
    "]"}]}], "\[IndentingNewLine]", "]"}]}], "Input",
 CellChangeTimes->{
  3.694416625474944*^9, 3.694416667063796*^9, {3.694416703695079*^9, 
   3.6944167074276776`*^9}, {3.6944167564985485`*^9, 3.694416936977309*^9}}],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.6944169439260607`*^9, 3.6944169439416547`*^9}}]
},
WindowSize->{1264, 583},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
FrontEndVersion->"9.0 for Microsoft Windows (64-bit) (January 25, 2013)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 23643, 659, 1927, "Input"],
Cell[24203, 681, 96, 1, 31, InheritFromParent]
}
]
*)

(* End of internal cache information *)
