(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     22384,        633]
NotebookOptionsPosition[     22101,        619]
NotebookOutlinePosition[     22444,        634]
CellTagsIndexPosition[     22401,        631]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"m", "=", "1"}], ";", 
   RowBox[{"g", "=", "9.81"}], ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"initial", " ", "conditions", " ", "setting"}], "*)"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"time", "=", "  ", "30"}], "  ", ";"}], "            ", 
  RowBox[{"(*", 
   RowBox[{"lenght", " ", "of", " ", "the", " ", "simulation"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"n", "=", "        ", "30"}], "  ", ";", "             ", 
   RowBox[{"(*", 
    RowBox[{
    "number", " ", "of", " ", "itarations", " ", "per", " ", "sec\:05ddnd"}], 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{"\[Phi]", "=", "        ", "36"}], "  ", ";", "            ", 
   RowBox[{"(*", 
    RowBox[{"initial", " ", "bead", " ", "location", " ", "in", " ", "deg"}], 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{"\[Omega]", "=", "          ", "5"}], "  ", ";", "            ", 
   RowBox[{"(*", 
    RowBox[{
    "angular", " ", "velocity", " ", "of", " ", "the", " ", "hop", " ", "in", 
     "  ", 
     FractionBox["rad", "sec"]}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{"v", "=", "        ", "10"}], "  ", ";", "            ", 
   RowBox[{"(*", 
    RowBox[{"inital", " ", "velocity", " ", "of", " ", "the", " ", "bead"}], 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{"r", "=", "          ", "2"}], "  ", ";", "            ", 
   RowBox[{"(*", 
    RowBox[{"radios", " ", "of", " ", "the", " ", "hoop"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{"damping", "=", 
    FractionBox["\[Omega]", "5"]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Garrow", "=", 
   RowBox[{"Graphics3D", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Text", "[", 
       RowBox[{
        RowBox[{"Style", "[", 
         RowBox[{"\"\<g\>\"", ",", "Large", ",", "Bold", ",", "Red"}], "]"}], 
        ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "5"}], ",", 
          RowBox[{"-", "5"}], ",", "0"}], "}"}]}], "]"}], ",", "Red", ",", 
      RowBox[{"Arrowheads", "[", "0.05", "]"}], ",", 
      RowBox[{"Arrow", "[", 
       RowBox[{"Tube", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "5"}], ",", 
             RowBox[{"-", "5"}], ",", "3"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "5"}], ",", 
             RowBox[{"-", "5"}], ",", "0"}], "}"}]}], "}"}], ",", "0.05"}], 
        "]"}], "]"}]}], "}"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"plato", "=", 
    RowBox[{"Graphics3D", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"RGBColor", "[", 
        RowBox[{"0.9", ",", "0.9", ",", "0.9"}], "]"}], ",", 
       RowBox[{"Cuboid", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "5.8"}], ",", 
            RowBox[{"-", "5.8"}], ",", 
            RowBox[{"-", "3.5"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"5.8", ",", "5.8", ",", 
            RowBox[{"-", "3"}]}], "}"}]}], "}"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Cylinder", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", 
             RowBox[{"-", "3"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", 
             RowBox[{"-", "2"}]}], "}"}]}], "}"}], ",", "2"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Cylinder", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", 
             RowBox[{"-", "2"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", 
             RowBox[{"-", "1.5"}]}], "}"}]}], "}"}], ",", "0.5"}], "]"}], ",",
        "Black", ",", 
       RowBox[{"Cylinder", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", 
             RowBox[{"-", "1.5"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", "0"}], "}"}]}], "}"}], ",", "0.1"}], 
        "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Arrowheads", "[", "0.05", "]"}], ",", 
       RowBox[{"Arrow", "[", 
        RowBox[{"BezierCurve", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", 
             RowBox[{"-", "3"}], ",", 
             RowBox[{"-", "2"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"3", ",", 
             RowBox[{"-", "3"}], ",", 
             RowBox[{"-", "2"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"3", ",", "0", ",", 
             RowBox[{"-", "2"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"3", ",", "3", ",", 
             RowBox[{"-", "2"}]}], "}"}]}], "}"}], "]"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Text", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<\[Omega]\>\"", ",", "Large", ",", "Bold", ",", "Black"}], 
          "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"3", ",", "4", ",", 
           RowBox[{"-", "2"}]}], "}"}]}], "]"}]}], "}"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"axisarrows", "=", 
    RowBox[{"Graphics3D", "[", 
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Text", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{"\"\<X\>\"", ",", "Large", ",", "Bold", ",", "Black"}], 
          "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"-", "6"}], ",", 
           RowBox[{"-", "3"}]}], "}"}]}], "]"}], ",", "Black", ",", 
       RowBox[{"Arrowheads", "[", "0.05", "]"}], ",", 
       RowBox[{"Arrow", "[", 
        RowBox[{"Tube", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "6"}], ",", 
              RowBox[{"-", "6"}], ",", 
              RowBox[{"-", "3"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1"}], ",", 
              RowBox[{"-", "6"}], ",", 
              RowBox[{"-", "3"}]}], "}"}]}], "}"}], ",", "0.05"}], "]"}], 
        "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Text", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{"\"\<Y\>\"", ",", "Large", ",", "Bold", ",", "Black"}], 
          "]"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "6"}], ",", "0", ",", 
           RowBox[{"-", "3"}]}], "}"}]}], "]"}], ",", "Black", ",", 
       RowBox[{"Arrowheads", "[", "0.05", "]"}], ",", 
       RowBox[{"Arrow", "[", 
        RowBox[{"Tube", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "6"}], ",", 
              RowBox[{"-", "6"}], ",", 
              RowBox[{"-", "3"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "6"}], ",", 
              RowBox[{"-", "1"}], ",", 
              RowBox[{"-", "3"}]}], "}"}]}], "}"}], ",", "0.05"}], "]"}], 
        "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Text", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{"\"\<Z\>\"", ",", "Large", ",", "Bold", ",", "Black"}], 
          "]"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "6"}], ",", 
           RowBox[{"-", "6"}], ",", "0"}], "}"}]}], "]"}], ",", "Black", ",", 
       RowBox[{"Arrowheads", "[", "0.05", "]"}], ",", 
       RowBox[{"Arrow", "[", 
        RowBox[{"Tube", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "6"}], ",", 
              RowBox[{"-", "6"}], ",", 
              RowBox[{"-", "3"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "6"}], ",", 
              RowBox[{"-", "6"}], ",", "1"}], "}"}]}], "}"}], ",", "0.05"}], 
         "]"}], "]"}]}], "\[IndentingNewLine]", "}"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"M", "=", 
    RowBox[{"Table", "[", 
     RowBox[{"0", ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "0", ",", 
        RowBox[{
         RowBox[{"time", "*", "n"}], "+", "1"}], ",", 
        FractionBox["1", "n"]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "1", ",", "3"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"M", "[", 
    RowBox[{"[", 
     RowBox[{"1", ",", "1"}], "]"}], "]"}], "=", 
   RowBox[{"\[Phi]", 
    FractionBox["\[Pi]", "180"]}]}], ";", 
  RowBox[{
   RowBox[{"M", "[", 
    RowBox[{"[", 
     RowBox[{"1", ",", "2"}], "]"}], "]"}], "=", 
   RowBox[{"v", 
    FractionBox["\[Pi]", "180"]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"For", "[", 
    RowBox[{
     RowBox[{"i", "=", "1"}], ",", 
     RowBox[{"i", "<=", 
      RowBox[{
       RowBox[{"n", "*", "time"}], "+", "2"}]}], ",", 
     RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"M", "[", 
         RowBox[{"[", 
          RowBox[{"i", ",", "3"}], "]"}], "]"}], "=", 
        RowBox[{"N", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"Sin", "[", 
             RowBox[{"M", "[", 
              RowBox[{"[", 
               RowBox[{"i", ",", "1"}], "]"}], "]"}], "]"}], 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               SuperscriptBox["\[Omega]", "2"], 
               RowBox[{"Cos", "[", 
                RowBox[{"M", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "1"}], "]"}], "]"}], "]"}]}], "-", 
              FractionBox["g", "r"]}], ")"}]}], "-", 
           RowBox[{"damping", "*", 
            RowBox[{"M", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}]}], ",", "3"}], "]"}]}], 
       ",", 
       RowBox[{"(*", 
        OverscriptBox["\[Theta]", "\[DoubleDot]"], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"M", "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"i", "+", "1"}], ",", "1"}], "]"}], "]"}], "=", 
        RowBox[{"N", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"M", "[", 
            RowBox[{"[", 
             RowBox[{"i", ",", "1"}], "]"}], "]"}], "+", 
           RowBox[{
            FractionBox["1", "n"], 
            RowBox[{"M", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}]}], ",", "3"}], "]"}]}], 
       ",", 
       RowBox[{"(*", 
        OverscriptBox["\[Theta]", "\[CenterDot]"], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"M", "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"i", "+", "1"}], ",", "2"}], "]"}], "]"}], "=", 
        RowBox[{"N", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"M", "[", 
            RowBox[{"[", 
             RowBox[{"i", ",", "2"}], "]"}], "]"}], "+", 
           RowBox[{
            FractionBox["1", "n"], 
            RowBox[{"M", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "3"}], "]"}], "]"}]}]}], ",", "3"}], 
         "]"}]}]}], 
      RowBox[{"(*", "\[Theta]", "*)"}], "\[IndentingNewLine]", "}"}]}], 
    "\[IndentingNewLine]", "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Manipulate", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Show", "[", 
     RowBox[{"(*", "simulation", "*)"}], "\[IndentingNewLine]", 
     RowBox[{
     "Garrow", ",", "plato", ",", "axisarrows", ",", "\[IndentingNewLine]", 
      RowBox[{"ParametricPlot3D", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"r", "*", 
           RowBox[{"Sin", "[", "\[Theta]", "]"}], 
           RowBox[{"Cos", "[", 
            RowBox[{"\[Omega]", "*", "t"}], "]"}]}], ",", 
          RowBox[{"r", "*", 
           RowBox[{"Sin", "[", "\[Theta]", "]"}], 
           RowBox[{"Sin", "[", 
            RowBox[{"\[Omega]", "*", "t"}], "]"}]}], ",", 
          RowBox[{"r", "+", 
           RowBox[{"r", "*", 
            RowBox[{"Cos", "[", "\[Theta]", "]"}]}]}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Theta]", ",", "0", ",", 
          RowBox[{"2", "\[Pi]"}]}], "}"}]}], "]"}], ",", 
      RowBox[{"(*", "hoop", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"Graphics3D", "[", 
       RowBox[{"{", 
        RowBox[{"Green", ",", 
         RowBox[{"Sphere", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"r", "*", 
              RowBox[{"Cos", "[", 
               RowBox[{"\[Omega]", "*", "t"}], "]"}], 
              RowBox[{"Sin", "[", 
               RowBox[{"\[Pi]", "-", 
                RowBox[{"M", "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{"t", "*", "n"}], ",", "1"}], "]"}], "]"}]}], 
               "]"}]}], ",", 
             RowBox[{"r", "*", 
              RowBox[{"Sin", "[", 
               RowBox[{"\[Omega]", "*", "t"}], "]"}], "*", 
              RowBox[{"Sin", "[", 
               RowBox[{"\[Pi]", "-", 
                RowBox[{"M", "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{"t", "*", "n"}], ",", "1"}], "]"}], "]"}]}], 
               "]"}]}], ",", 
             RowBox[{"r", "+", 
              RowBox[{"r", "*", 
               RowBox[{"Cos", "[", 
                RowBox[{"\[Pi]", "-", 
                 RowBox[{"M", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"t", "*", "n"}], ",", "1"}], "]"}], "]"}]}], 
                "]"}]}]}]}], "}"}], ",", 
           FractionBox["1", "4"]}], "]"}]}], "}"}], "]"}], ",", 
      RowBox[{"(*", "bead", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"PlotRange", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "6.5"}], ",", "6.5"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "6.5"}], ",", "6.5"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "5"}], ",", "10.5"}], "}"}]}], "}"}]}], ",", 
      RowBox[{"Boxed", "\[Rule]", "False"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "350"}]}], "\[IndentingNewLine]", "]"}],
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"Show", "[", 
     RowBox[{"(*", "info_bar", "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Graphics", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Circle", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "0"}], "}"}], ",", "1"}], "]"}], ",", 
         RowBox[{"Line", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", 
              RowBox[{"-", "1"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", 
              RowBox[{"-", "1.5"}]}], "}"}]}], "}"}], "]"}]}], "}"}], "]"}], 
      ",", "\[IndentingNewLine]", 
      RowBox[{"Graphics", "[", 
       RowBox[{"Disk", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "1"}], "}"}], ",", "0.1"}], "]"}], "]"}], ",", 
      RowBox[{"Graphics", "[", 
       RowBox[{"Text", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Unstable equilibria\>\"", ",", "20", ",", "Bold", ",", 
           "Black"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "2.5"}], "}"}]}], "]"}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Graphics", "[", 
       RowBox[{"{", 
        RowBox[{"Blue", ",", 
         RowBox[{"Disk", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", 
             RowBox[{"-", "1"}]}], "}"}], ",", "0.1"}], "]"}], ",", 
         RowBox[{"Disk", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Cos", "[", 
              RowBox[{"-", 
               RowBox[{"ArcTan", "[", 
                FractionBox["g", 
                 RowBox[{
                  RowBox[{
                   SuperscriptBox["\[Omega]", "2"], "r"}], "+", "0.001"}]], 
                "]"}]}], "]"}], ",", 
             RowBox[{"Sin", "[", 
              RowBox[{"-", 
               RowBox[{"ArcTan", "[", 
                FractionBox["g", 
                 RowBox[{
                  RowBox[{
                   SuperscriptBox["\[Omega]", "2"], "r"}], "+", "0.001"}]], 
                "]"}]}], "]"}]}], "}"}], ",", "0.1"}], "]"}]}], "}"}], "]"}], 
      ",", 
      RowBox[{"Graphics", "[", 
       RowBox[{"Text", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<stable equilibria\>\"", ",", "20", ",", "Bold", ",", "Blue"}], 
          "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "2"}], "}"}]}], "]"}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Graphics", "[", 
       RowBox[{"Text", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"N", "[", 
             RowBox[{
              RowBox[{"90", "-", 
               RowBox[{
                RowBox[{"ArcTan", "[", 
                 FractionBox["g", 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox["\[Omega]", "2"], "r"}], "+", "0.001"}]], 
                 "]"}], 
                FractionBox["180", "\[Pi]"]}]}], ",", "2"}], "]"}], 
            "\"\<Deg\>\""}], ",", "20", ",", "Bold", ",", "Blue"}], "]"}], 
         ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1.5"}], "}"}]}], "]"}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"ImageSize", "\[Rule]", "200"}]}], "\[IndentingNewLine]", 
     "]"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"Row", "[", 
    RowBox[{"{", 
     RowBox[{"Style", "[", 
      RowBox[{"\"\<Inital conditions:\>\"", ",", "20", ",", "Bold"}], "]"}], 
     "}"}], "]"}], ",", "\[IndentingNewLine]", 
   RowBox[{"Row", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Style", "[", 
       RowBox[{"\"\<Radios r in [Meter]   \>\"", ",", "20"}], "]"}], ",", 
      RowBox[{
       RowBox[{"Style", "[", 
        RowBox[{"r", "            ", ",", "30"}], "]"}], 
       "\[IndentingNewLine]", 
       RowBox[{"Style", "[", 
        RowBox[{
        "\"\<                Angular velocity \[Omega] in [\!\(\*FractionBox[\
\(Rad\), \(Sec\)]\)]     \>\"", ",", "20"}], "]"}]}], ",", 
      RowBox[{"Style", "[", 
       RowBox[{"\[Omega]", "            ", ",", "30"}], "]"}]}], "}"}], "]"}],
    ",", "\[IndentingNewLine]", 
   RowBox[{"Row", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Style", "[", 
       RowBox[{"\"\<Initial location \[Theta] in [Deg]    \>\"", ",", "20"}], 
       "]"}], ",", 
      RowBox[{"Style", "[", 
       RowBox[{"\[Phi]", "            ", ",", "30"}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Style", "[", 
       RowBox[{
       "\"\<    Initial velocity \!\(\*OverscriptBox[\(\[Theta]\), \(\
\[CenterDot]\)]\) in  [\!\(\*FractionBox[\(Deg\), \(Sec\)]\)]       \>\"", 
        ",", "20"}], "]"}], ",", 
      RowBox[{"Style", "[", " ", 
       RowBox[{"v", "           ", ",", "30"}], "]"}]}], "}"}], "]"}], ",", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"Row", "[", 
    RowBox[{"{", 
     RowBox[{"Style", "[", 
      RowBox[{"\"\< \>\"", ",", "20"}], "]"}], "}"}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"Row", "[", 
    RowBox[{"{", 
     RowBox[{"Style", "[", 
      RowBox[{"\"\<Evolution in time: \>\"", ",", "20", ",", "Bold"}], "]"}], 
     "}"}], "]"}], ",", "\[IndentingNewLine]", 
   RowBox[{"Row", "[", 
    RowBox[{"{", 
     RowBox[{"Style", "[", 
      RowBox[{"\"\< \>\"", ",", "20"}], "]"}], "}"}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"Row", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Style", "[", 
       RowBox[{"\"\<Time t in Sec\>\"", ",", "20"}], "]"}], ",", "  ", 
      RowBox[{"Control", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"t", ",", 
           FractionBox["1", "n"], ",", "\"\<\>\""}], "}"}], ",", 
         FractionBox["1", "n"], ",", "time", ",", 
         FractionBox["1", "n"], ",", 
         RowBox[{"Appearance", "\[Rule]", "\"\<Labeled\>\""}], ",", 
         RowBox[{"ImageSize", "\[Rule]", "Large"}], ",", 
         RowBox[{"AnimationRate", "\[Rule]", "n"}]}], "}"}], "]"}]}], "}"}], 
    "]"}]}], "\[IndentingNewLine]", "]"}]}], "Input",
 CellChangeTimes->{{3.6944163328542542`*^9, 3.694416337958824*^9}, {
  3.697032632425844*^9, 3.6970326392577124`*^9}, {3.6970338353932424`*^9, 
  3.6970338577318816`*^9}}],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.694416352609169*^9, 3.6944163526247435`*^9}}]
},
WindowSize->{1264, 583},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
FrontEndVersion->"9.0 for Microsoft Windows (64-bit) (January 25, 2013)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 21443, 594, 1659, "Input"],
Cell[22003, 616, 94, 1, 31, "Input"]
}
]
*)

(* End of internal cache information *)
