(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     31290,        855]
NotebookOptionsPosition[     31045,        842]
NotebookOutlinePosition[     31388,        857]
CellTagsIndexPosition[     31345,        854]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"g", "=", "9.81"}], ";", 
   RowBox[{"m", "=", "1"}], ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"initial", " ", "conditions", " ", "setting"}], "*)"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"time", "=", "   ", "10"}], "  ", ";"}], "              ", 
  RowBox[{"(*", 
   RowBox[{"lenght", " ", "of", " ", "the", " ", "simulation"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"n", "=", "        ", "100"}], "  ", ";", "               ", 
   RowBox[{"(*", 
    RowBox[{
    "number", " ", "of", " ", "itarations", " ", "per", " ", "second"}], 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{"\[Phi]", "=", "             ", "0"}], "  ", ";", 
   "                ", 
   RowBox[{"(*", 
    RowBox[{"initial", " ", "mass", " ", "location", " ", "in", " ", "deg"}], 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{"\[Omega]", "=", "             ", "3"}], "  ", ";", 
   "                ", 
   RowBox[{"(*", 
    RowBox[{
    "angular", " ", "velocity", " ", "of", " ", "the", " ", "Carousel", " ", 
     "in", "  ", 
     FractionBox["rad", "sec"]}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{"v", "=", "            ", "0"}], "  ", ";", "                 ", 
   RowBox[{"(*", 
    RowBox[{"inital", " ", "velocity", " ", "of", " ", "the", " ", "mass"}], 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{"l", "=", "             ", "4"}], "  ", ";", "                  ", 
   RowBox[{"(*", 
    RowBox[{
    "radios", " ", "of", " ", "line", " ", "holding", " ", "the", " ", 
     "mass"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{"damping", "=", 
    RowBox[{
     FractionBox[
      RowBox[{"3", "\[Omega]"}], "5"], "+", 
     FractionBox["1", "2"]}]}], ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Garrow", "=", 
   RowBox[{"Graphics3D", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Text", "[", 
       RowBox[{
        RowBox[{"Style", "[", 
         RowBox[{"\"\<g\>\"", ",", "Large", ",", "Bold", ",", "Red"}], "]"}], 
        ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "7"}], ",", "7", ",", "1.25"}], "}"}]}], "]"}], ",", 
      "Red", ",", 
      RowBox[{"Arrowheads", "[", "0.05", "]"}], ",", 
      RowBox[{"Arrow", "[", 
       RowBox[{"Tube", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "7"}], ",", "7", ",", "5"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "7"}], ",", "7", ",", "1.5"}], "}"}]}], "}"}], ",", 
         "0.05"}], "]"}], "]"}]}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Carousel", "=", 
    RowBox[{"Graphics3D", "[", 
     RowBox[{"{", 
      RowBox[{"Blue", ",", 
       RowBox[{"Cylinder", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", 
             RowBox[{"-", "2"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", "5"}], "}"}]}], "}"}], ",", 
         FractionBox["1", "4"]}], "]"}], ",", 
       RowBox[{"Cuboid", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "4"}], ",", 
            RowBox[{"-", "4"}], ",", 
            RowBox[{"-", "2"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"4", ",", "4", ",", 
            RowBox[{"-", "1.5"}]}], "}"}]}], "}"}], "]"}], ",", "Red", ",", 
       RowBox[{"Cylinder", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", "5"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", "5.5"}], "}"}]}], "}"}], ",", "3"}], 
        "]"}], ",", 
       RowBox[{"Cone", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", "5.5"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", "7"}], "}"}]}], "}"}], ",", "3"}], 
        "]"}]}], "}"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"M", "=", 
    RowBox[{"Table", "[", 
     RowBox[{"0", ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "0", ",", 
        RowBox[{
         RowBox[{"time", "*", "n"}], "+", "1"}], ",", 
        FractionBox["1", "n"]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "1", ",", "3"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"M", "[", 
    RowBox[{"[", 
     RowBox[{"1", ",", "1"}], "]"}], "]"}], "=", 
   RowBox[{"\[Phi]", " ", 
    FractionBox["\[Pi]", "180"]}]}], ";", 
  RowBox[{
   RowBox[{"M", "[", 
    RowBox[{"[", 
     RowBox[{"1", ",", "2"}], "]"}], "]"}], "=", 
   RowBox[{"v", 
    FractionBox["\[Pi]", "180"]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"For", "[", 
    RowBox[{
     RowBox[{"i", "=", "1"}], ",", 
     RowBox[{"i", "<=", 
      RowBox[{
       RowBox[{"time", "*", "n"}], "+", "2"}]}], ",", 
     RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"M", "[", 
         RowBox[{"[", 
          RowBox[{"i", ",", "3"}], "]"}], "]"}], "=", 
        RowBox[{"N", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            FractionBox[
             SuperscriptBox["\[Omega]", "2"], "l"], "*", 
            RowBox[{"Cos", "[", 
             RowBox[{"M", "[", 
              RowBox[{"[", 
               RowBox[{"i", ",", "1"}], "]"}], "]"}], "]"}], 
            RowBox[{"(", 
             RowBox[{"3", "+", 
              RowBox[{"l", "*", 
               RowBox[{"Sin", "[", 
                RowBox[{"M", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "1"}], "]"}], "]"}], "]"}]}]}], ")"}]}], 
           "-", 
           RowBox[{
            FractionBox["g", "l"], 
            RowBox[{"Sin", "[", 
             RowBox[{"M", "[", 
              RowBox[{"[", 
               RowBox[{"i", ",", "1"}], "]"}], "]"}], "]"}]}], "-", 
           RowBox[{"damping", "*", 
            RowBox[{"M", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}]}], ",", "2"}], "]"}]}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"M", "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"i", "+", "1"}], ",", "1"}], "]"}], "]"}], "=", 
        RowBox[{"N", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"M", "[", 
            RowBox[{"[", 
             RowBox[{"i", ",", "1"}], "]"}], "]"}], "+", 
           RowBox[{
            FractionBox["1", "n"], 
            RowBox[{"M", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}]}], ",", "2"}], "]"}]}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"M", "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"i", "+", "1"}], ",", "2"}], "]"}], "]"}], "=", 
        RowBox[{"N", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"M", "[", 
            RowBox[{"[", 
             RowBox[{"i", ",", "2"}], "]"}], "]"}], "+", 
           RowBox[{
            FractionBox["1", "n"], 
            RowBox[{"M", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "3"}], "]"}], "]"}]}]}], ",", "2"}], 
         "]"}]}]}], "\[IndentingNewLine]", "}"}]}], "\[IndentingNewLine]", 
    "]"}], ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[CapitalPhi]s", "=", 
   RowBox[{"M", "[", 
    RowBox[{"[", 
     RowBox[{";;", ",", "1"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Rs", "=", 
   SqrtBox[
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"5", "-", 
        RowBox[{"l", "*", 
         RowBox[{"Cos", "[", "\[CapitalPhi]s", "]"}]}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"3", "+", 
        RowBox[{"l", "*", 
         RowBox[{"Sin", "[", "\[CapitalPhi]s", "]"}]}]}], ")"}], "2"]}]]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Zs", "=", 
   RowBox[{"5", "-", 
    RowBox[{"l", "*", 
     RowBox[{"Cos", "[", "\[CapitalPhi]s", "]"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"\[CapitalTheta]s", "=", 
    RowBox[{"ArcSin", "[", 
     FractionBox["Zs", "Rs"], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Manipulate", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Show", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Graphics3D", "[", 
       RowBox[{"{", 
        RowBox[{"Green", ",", 
         RowBox[{"Sphere", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"Cos", "[", 
               RowBox[{"\[CapitalTheta]s", "[", 
                RowBox[{"[", 
                 RowBox[{"t", "*", "n"}], "]"}], "]"}], "]"}], "*", 
              RowBox[{"Rs", "[", 
               RowBox[{"[", 
                RowBox[{"t", "*", "n"}], "]"}], "]"}], "*", 
              RowBox[{"Cos", "[", 
               RowBox[{"\[Omega]", " ", "*", "t"}], "]"}]}], ",", 
             RowBox[{
              RowBox[{"Cos", "[", 
               RowBox[{"\[CapitalTheta]s", "[", 
                RowBox[{"[", 
                 RowBox[{"t", "*", "n"}], "]"}], "]"}], "]"}], "*", 
              RowBox[{"Rs", "[", 
               RowBox[{"[", 
                RowBox[{"t", "*", "n"}], "]"}], "]"}], "*", 
              RowBox[{"Sin", "[", 
               RowBox[{"\[Omega]", "*", "t"}], "]"}]}], ",", 
             RowBox[{"Zs", "[", 
              RowBox[{"[", 
               RowBox[{"t", "*", "n"}], "]"}], "]"}]}], "}"}], ",", 
           FractionBox["1", "4"]}], "]"}]}], "}"}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Graphics3D", "[", 
       RowBox[{"{", 
        RowBox[{"Thick", ",", 
         RowBox[{"Line", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"3", "*", 
               RowBox[{"Cos", "[", 
                RowBox[{"\[Omega]", "*", "t"}], "]"}]}], ",", 
              RowBox[{"3", "*", 
               RowBox[{"Sin", "[", 
                RowBox[{"\[Omega]", "*", "t"}], "]"}]}], ",", "5"}], "}"}], 
            ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"Cos", "[", 
                RowBox[{"\[CapitalTheta]s", "[", 
                 RowBox[{"[", 
                  RowBox[{"t", "*", "n"}], "]"}], "]"}], "]"}], "*", 
               RowBox[{"Rs", "[", 
                RowBox[{"[", 
                 RowBox[{"t", "*", "n"}], "]"}], "]"}], "*", 
               RowBox[{"Cos", "[", 
                RowBox[{"\[Omega]", "*", "t"}], "]"}]}], ",", 
              RowBox[{
               RowBox[{"Cos", "[", 
                RowBox[{"\[CapitalTheta]s", "[", 
                 RowBox[{"[", 
                  RowBox[{"t", "*", "n"}], "]"}], "]"}], "]"}], "*", 
               RowBox[{"Rs", "[", 
                RowBox[{"[", 
                 RowBox[{"t", "*", "n"}], "]"}], "]"}], "*", 
               RowBox[{"Sin", "[", 
                RowBox[{"\[Omega]", "*", "t"}], "]"}]}], ",", 
              RowBox[{"Zs", "[", 
               RowBox[{"[", 
                RowBox[{"t", "*", "n"}], "]"}], "]"}]}], "}"}]}], "}"}], 
          "]"}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Graphics3D", "[", 
       RowBox[{"{", 
        RowBox[{"Black", ",", 
         RowBox[{"Sphere", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"Cos", "[", 
               RowBox[{"\[CapitalTheta]s", "[", 
                RowBox[{"[", 
                 RowBox[{"t", "*", "n"}], "]"}], "]"}], "]"}], "*", 
              RowBox[{"Rs", "[", 
               RowBox[{"[", 
                RowBox[{"t", "*", "n"}], "]"}], "]"}], "*", 
              RowBox[{"Cos", "[", 
               RowBox[{
                RowBox[{"\[Omega]", " ", "*", "t"}], "+", 
                FractionBox["\[Pi]", "2"]}], "]"}]}], ",", 
             RowBox[{
              RowBox[{"Cos", "[", 
               RowBox[{"\[CapitalTheta]s", "[", 
                RowBox[{"[", 
                 RowBox[{"t", "*", "n"}], "]"}], "]"}], "]"}], "*", 
              RowBox[{"Rs", "[", 
               RowBox[{"[", 
                RowBox[{"t", "*", "n"}], "]"}], "]"}], "*", 
              RowBox[{"Sin", "[", 
               RowBox[{
                RowBox[{"\[Omega]", "*", "t"}], "+", 
                FractionBox["\[Pi]", "2"]}], "]"}]}], ",", 
             RowBox[{"Zs", "[", 
              RowBox[{"[", 
               RowBox[{"t", "*", "n"}], "]"}], "]"}]}], "}"}], ",", 
           FractionBox["1", "4"]}], "]"}]}], "}"}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Graphics3D", "[", 
       RowBox[{"{", 
        RowBox[{"Thick", ",", 
         RowBox[{"Line", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"3", "*", 
               RowBox[{"Cos", "[", 
                RowBox[{
                 RowBox[{"\[Omega]", "*", "t"}], "+", 
                 FractionBox["\[Pi]", "2"]}], "]"}]}], ",", 
              RowBox[{"3", "*", 
               RowBox[{"Sin", "[", 
                RowBox[{
                 RowBox[{"\[Omega]", "*", "t"}], "+", 
                 FractionBox["\[Pi]", "2"]}], "]"}]}], ",", "5"}], "}"}], ",",
             "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"Cos", "[", 
                RowBox[{"\[CapitalTheta]s", "[", 
                 RowBox[{"[", 
                  RowBox[{"t", "*", "n"}], "]"}], "]"}], "]"}], "*", 
               RowBox[{"Rs", "[", 
                RowBox[{"[", 
                 RowBox[{"t", "*", "n"}], "]"}], "]"}], "*", 
               RowBox[{"Cos", "[", 
                RowBox[{
                 RowBox[{"\[Omega]", "*", "t"}], "+", 
                 FractionBox["\[Pi]", "2"]}], "]"}]}], ",", 
              RowBox[{
               RowBox[{"Cos", "[", 
                RowBox[{"\[CapitalTheta]s", "[", 
                 RowBox[{"[", 
                  RowBox[{"t", "*", "n"}], "]"}], "]"}], "]"}], "*", 
               RowBox[{"Rs", "[", 
                RowBox[{"[", 
                 RowBox[{"t", "*", "n"}], "]"}], "]"}], "*", 
               RowBox[{"Sin", "[", 
                RowBox[{
                 RowBox[{"\[Omega]", "*", "t"}], "+", 
                 FractionBox["\[Pi]", "2"]}], "]"}]}], ",", 
              RowBox[{"Zs", "[", 
               RowBox[{"[", 
                RowBox[{"t", "*", "n"}], "]"}], "]"}]}], "}"}]}], "}"}], 
          "]"}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Graphics3D", "[", 
       RowBox[{"{", 
        RowBox[{"Black", ",", 
         RowBox[{"Sphere", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"Cos", "[", 
               RowBox[{"\[CapitalTheta]s", "[", 
                RowBox[{"[", 
                 RowBox[{"t", "*", "n"}], "]"}], "]"}], "]"}], "*", 
              RowBox[{"Rs", "[", 
               RowBox[{"[", 
                RowBox[{"t", "*", "n"}], "]"}], "]"}], "*", 
              RowBox[{"Cos", "[", 
               RowBox[{
                RowBox[{"\[Omega]", " ", "*", "t"}], "+", "\[Pi]"}], "]"}]}], 
             ",", 
             RowBox[{
              RowBox[{"Cos", "[", 
               RowBox[{"\[CapitalTheta]s", "[", 
                RowBox[{"[", 
                 RowBox[{"t", "*", "n"}], "]"}], "]"}], "]"}], "*", 
              RowBox[{"Rs", "[", 
               RowBox[{"[", 
                RowBox[{"t", "*", "n"}], "]"}], "]"}], "*", 
              RowBox[{"Sin", "[", 
               RowBox[{
                RowBox[{"\[Omega]", "*", "t"}], "+", "\[Pi]"}], "]"}]}], ",", 
             RowBox[{"Zs", "[", 
              RowBox[{"[", 
               RowBox[{"t", "*", "n"}], "]"}], "]"}]}], "}"}], ",", 
           FractionBox["1", "4"]}], "]"}]}], "}"}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Graphics3D", "[", 
       RowBox[{"{", 
        RowBox[{"Thick", ",", 
         RowBox[{"Line", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"3", "*", 
               RowBox[{"Cos", "[", 
                RowBox[{
                 RowBox[{"\[Omega]", "*", "t"}], "+", "\[Pi]"}], "]"}]}], ",", 
              RowBox[{"3", "*", 
               RowBox[{"Sin", "[", 
                RowBox[{
                 RowBox[{"\[Omega]", "*", "t"}], "+", "\[Pi]"}], "]"}]}], ",",
               "5"}], "}"}], ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"Cos", "[", 
                RowBox[{"\[CapitalTheta]s", "[", 
                 RowBox[{"[", 
                  RowBox[{"t", "*", "n"}], "]"}], "]"}], "]"}], "*", 
               RowBox[{"Rs", "[", 
                RowBox[{"[", 
                 RowBox[{"t", "*", "n"}], "]"}], "]"}], "*", 
               RowBox[{"Cos", "[", 
                RowBox[{
                 RowBox[{"\[Omega]", "*", "t"}], "+", "\[Pi]"}], "]"}]}], ",", 
              RowBox[{
               RowBox[{"Cos", "[", 
                RowBox[{"\[CapitalTheta]s", "[", 
                 RowBox[{"[", 
                  RowBox[{"t", "*", "n"}], "]"}], "]"}], "]"}], "*", 
               RowBox[{"Rs", "[", 
                RowBox[{"[", 
                 RowBox[{"t", "*", "n"}], "]"}], "]"}], "*", 
               RowBox[{"Sin", "[", 
                RowBox[{
                 RowBox[{"\[Omega]", "*", "t"}], "+", "\[Pi]"}], "]"}]}], ",", 
              RowBox[{"Zs", "[", 
               RowBox[{"[", 
                RowBox[{"t", "*", "n"}], "]"}], "]"}]}], "}"}]}], "}"}], 
          "]"}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Graphics3D", "[", 
       RowBox[{"{", 
        RowBox[{"Black", ",", 
         RowBox[{"Sphere", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"Cos", "[", 
               RowBox[{"\[CapitalTheta]s", "[", 
                RowBox[{"[", 
                 RowBox[{"t", "*", "n"}], "]"}], "]"}], "]"}], "*", 
              RowBox[{"Rs", "[", 
               RowBox[{"[", 
                RowBox[{"t", "*", "n"}], "]"}], "]"}], "*", 
              RowBox[{"Cos", "[", 
               RowBox[{
                RowBox[{"\[Omega]", " ", "*", "t"}], "+", 
                FractionBox[
                 RowBox[{"3", "\[Pi]"}], "2"]}], "]"}]}], ",", 
             RowBox[{
              RowBox[{"Cos", "[", 
               RowBox[{"\[CapitalTheta]s", "[", 
                RowBox[{"[", 
                 RowBox[{"t", "*", "n"}], "]"}], "]"}], "]"}], "*", 
              RowBox[{"Rs", "[", 
               RowBox[{"[", 
                RowBox[{"t", "*", "n"}], "]"}], "]"}], "*", 
              RowBox[{"Sin", "[", 
               RowBox[{
                RowBox[{"\[Omega]", "*", "t"}], "+", 
                FractionBox[
                 RowBox[{"3", "\[Pi]"}], "2"]}], "]"}]}], ",", 
             RowBox[{"Zs", "[", 
              RowBox[{"[", 
               RowBox[{"t", "*", "n"}], "]"}], "]"}]}], "}"}], ",", 
           FractionBox["1", "4"]}], "]"}]}], "}"}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Graphics3D", "[", 
       RowBox[{"{", 
        RowBox[{"Thick", ",", 
         RowBox[{"Line", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"3", "*", 
               RowBox[{"Cos", "[", 
                RowBox[{
                 RowBox[{"\[Omega]", "*", "t"}], "+", 
                 FractionBox[
                  RowBox[{"3", "\[Pi]"}], "2"]}], "]"}]}], ",", 
              RowBox[{"3", "*", 
               RowBox[{"Sin", "[", 
                RowBox[{
                 RowBox[{"\[Omega]", "*", "t"}], "+", 
                 FractionBox[
                  RowBox[{"3", "\[Pi]"}], "2"]}], "]"}]}], ",", "5"}], "}"}], 
            ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"Cos", "[", 
                RowBox[{"\[CapitalTheta]s", "[", 
                 RowBox[{"[", 
                  RowBox[{"t", "*", "n"}], "]"}], "]"}], "]"}], "*", 
               RowBox[{"Rs", "[", 
                RowBox[{"[", 
                 RowBox[{"t", "*", "n"}], "]"}], "]"}], "*", 
               RowBox[{"Cos", "[", 
                RowBox[{
                 RowBox[{"\[Omega]", "*", "t"}], "+", 
                 FractionBox[
                  RowBox[{"3", "\[Pi]"}], "2"]}], "]"}]}], ",", 
              RowBox[{
               RowBox[{"Cos", "[", 
                RowBox[{"\[CapitalTheta]s", "[", 
                 RowBox[{"[", 
                  RowBox[{"t", "*", "n"}], "]"}], "]"}], "]"}], "*", 
               RowBox[{"Rs", "[", 
                RowBox[{"[", 
                 RowBox[{"t", "*", "n"}], "]"}], "]"}], "*", 
               RowBox[{"Sin", "[", 
                RowBox[{
                 RowBox[{"\[Omega]", "*", "t"}], "+", 
                 FractionBox[
                  RowBox[{"3", "\[Pi]"}], "2"]}], "]"}]}], ",", 
              RowBox[{"Zs", "[", 
               RowBox[{"[", 
                RowBox[{"t", "*", "n"}], "]"}], "]"}]}], "}"}]}], "}"}], 
          "]"}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "Garrow", ",", "Carousel",
       ",", "\[IndentingNewLine]", 
      RowBox[{"PlotRange", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "10"}], ",", "10"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "10"}], ",", "10"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "3"}], ",", "7"}], "}"}]}], "}"}]}], ",", 
      RowBox[{"Boxed", "\[Rule]", "False"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "750"}]}], "]"}], "\[IndentingNewLine]",
     "\[IndentingNewLine]", 
    RowBox[{"Show", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Graphics", "[", 
       RowBox[{"{", 
        RowBox[{"Red", ",", 
         RowBox[{"Polygon", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "7"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "5.5"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"3", ",", "5.5"}], "}"}]}], "}"}], "]"}], ",", 
         RowBox[{"Rectangle", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "5.5"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "5"}], "}"}]}], "]"}]}], "}"}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Graphics", "[", 
       RowBox[{"{", 
        RowBox[{"Blue", ",", 
         RowBox[{"Rectangle", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "5"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             FractionBox["1", "8"], ",", 
             RowBox[{"-", "1.5"}]}], "}"}]}], "]"}], ",", 
         RowBox[{"Rectangle", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", 
             RowBox[{"-", "1.5"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"4", ",", 
             RowBox[{"-", "2"}]}], "}"}]}], "]"}]}], "}"}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Graphics", "[", 
       RowBox[{"{", 
        RowBox[{"Thick", ",", 
         RowBox[{"Line", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "5"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Rs", "[", 
               RowBox[{"[", 
                RowBox[{"t", "*", "n"}], "]"}], "]"}], ",", 
              RowBox[{"Zs", "[", 
               RowBox[{"[", 
                RowBox[{"t", "*", "n"}], "]"}], "]"}]}], "}"}]}], "}"}], 
          "]"}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Graphics", "[", 
       RowBox[{"{", 
        RowBox[{"Green", ",", 
         RowBox[{"Disk", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Rs", "[", 
              RowBox[{"[", 
               RowBox[{"t", "*", "n"}], "]"}], "]"}], ",", 
             RowBox[{"Zs", "[", 
              RowBox[{"[", 
               RowBox[{"t", "*", "n"}], "]"}], "]"}]}], "}"}], ",", 
           FractionBox["1", "2"]}], "]"}]}], "}"}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Graphics", "[", 
       RowBox[{"Text", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<stable equilibria\>\"", ",", "20", ",", "Bold", ",", "Blue"}], 
          "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "10"}], "}"}]}], "]"}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"a", "=", 
        RowBox[{"NSolve", "[", 
         RowBox[{
          RowBox[{"Rationalize", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"-", "g"}], "*", 
               RowBox[{"Sin", "[", "\[Theta]", "]"}]}], "+", 
              RowBox[{
               SuperscriptBox["\[Omega]", "2"], 
               RowBox[{"Cos", "[", "\[Theta]", "]"}], 
               RowBox[{"(", 
                RowBox[{"3", "+", 
                 RowBox[{"l", "*", 
                  RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}], ")"}]}]}], 
             "\[Equal]", "0"}], "&&", " ", 
            RowBox[{"\[Theta]", "\[GreaterEqual]", " ", "0"}], " ", "&&", " ", 
            RowBox[{"\[Theta]", "\[LessEqual]", " ", 
             FractionBox["\[Pi]", "2"]}]}], "]"}], ",", "\[Theta]", ",", 
          "Reals", ",", 
          RowBox[{"WorkingPrecision", "\[Rule]", "3"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Graphics", "[", 
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
            RowBox[{"a", "[", 
             RowBox[{"[", "1", "]"}], "]"}], " ", ",", "20", ",", "Bold", ",",
             "Blue"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"4", ",", "8"}], "}"}]}], "]"}], "]"}]}], ",", 
      RowBox[{"Graphics", "[", 
       RowBox[{"Text", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{"\"\<Rad\>\"", " ", ",", "20", ",", "Bold", ",", "Blue"}], 
          "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"8", ",", "8"}], "}"}]}], "]"}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"PlotRange", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"12", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "2"}], ",", "11"}], "}"}]}], "}"}]}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "250"}]}], "\[IndentingNewLine]", 
     "]"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"Row", "[", 
    RowBox[{"{", 
     RowBox[{"Style", "[", 
      RowBox[{"\"\<Inital conditions:\>\"", ",", "20", ",", "Bold"}], "]"}], 
     "}"}], "]"}], ",", "\[IndentingNewLine]", 
   RowBox[{"Row", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Style", "[", 
       RowBox[{"\"\<Lenght of wire l  in [Meter]   \>\"", ",", "20"}], "]"}], 
      ",", 
      RowBox[{"Style", "[", 
       RowBox[{"l", "            ", ",", "30"}], "]"}], ",", 
      RowBox[{"Style", "[", 
       RowBox[{
       "\"\<                Angular velocity \[Omega] in \
[\!\(\*FractionBox[\(Rad\), \(Sec\)]\)]     \>\"", ",", "20"}], "]"}], ",", 
      RowBox[{"Style", "[", 
       RowBox[{"\[Omega]", "            ", ",", "30"}], "]"}]}], "}"}], "]"}],
    ",", "\[IndentingNewLine]", 
   RowBox[{"Row", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Style", "[", 
       RowBox[{"\"\<Initial location \[Theta] in [Deg]    \>\"", ",", "20"}], 
       "]"}], ",", 
      RowBox[{"Style", "[", 
       RowBox[{"\[Phi]", "            ", ",", "30"}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Style", "[", 
       RowBox[{
       "\"\<               Initial velocity \!\(\*OverscriptBox[\(\[Theta]\), \
\(\[CenterDot]\)]\) in  [\!\(\*FractionBox[\(Deg\), \(Sec\)]\)]       \>\"", 
        ",", "20"}], "]"}], ",", 
      RowBox[{"Style", "[", " ", 
       RowBox[{"v", "           ", ",", "30"}], "]"}]}], "}"}], "]"}], ",", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"Row", "[", 
    RowBox[{"{", 
     RowBox[{"Style", "[", 
      RowBox[{"\"\< \>\"", ",", "20"}], "]"}], "}"}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"Row", "[", 
    RowBox[{"{", 
     RowBox[{"Style", "[", 
      RowBox[{"\"\<Evolution in time: \>\"", ",", "20", ",", "Bold"}], "]"}], 
     "}"}], "]"}], ",", "\[IndentingNewLine]", 
   RowBox[{"Row", "[", 
    RowBox[{"{", 
     RowBox[{"Style", "[", 
      RowBox[{"\"\< \>\"", ",", "20"}], "]"}], "}"}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"Row", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Style", "[", 
       RowBox[{"\"\<Time t in Sec\>\"", ",", "20"}], "]"}], ",", "  ", 
      RowBox[{"Control", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"t", ",", 
           FractionBox["1", "n"], ",", "\"\<\>\""}], "}"}], ",", 
         FractionBox["1", "n"], ",", "time", ",", 
         FractionBox["1", "n"], ",", 
         RowBox[{"Appearance", "\[Rule]", "\"\<Labeled\>\""}], ",", 
         RowBox[{"ImageSize", "\[Rule]", "Large"}], ",", 
         RowBox[{"AnimationRate", "\[Rule]", "n"}]}], "}"}], "]"}]}], "}"}], 
    "]"}]}], "\[IndentingNewLine]", "]"}]}], "Input",
 CellChangeTimes->{{3.697032670002652*^9, 3.6970326700061593`*^9}, {
  3.6970327020982494`*^9, 3.697032704797393*^9}, {3.697033909238872*^9, 
  3.6970339296617517`*^9}}]
},
WindowSize->{1264, 583},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
FrontEndVersion->"9.0 for Microsoft Windows (64-bit) (January 25, 2013)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 30484, 820, 1987, "Input"]
}
]
*)

(* End of internal cache information *)
